/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|*  * Sparc Disassembler                                                      *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/


#include "llvm/MC/MCInst.h"
#include "llvm/MC/MCSubtargetInfo.h"
#include "llvm/Support/DataTypes.h"
#include "llvm/Support/Debug.h"
#include "llvm/Support/LEB128.h"
#include "llvm/Support/raw_ostream.h"
#include "llvm/TargetParser/SubtargetFeature.h"
#include <assert.h>

namespace {

// Helper functions for extracting fields from encoded instructions.
// InsnType must either be integral or an APInt-like object that must:
// * be default-constructible and copy-constructible
// * be constructible from an APInt (this can be private)
// * Support insertBits(bits, startBit, numBits)
// * Support extractBitsAsZExtValue(numBits, startBit)
// * Support the ~, &, ==, and != operators with other objects of the same type
// * Support the != and bitwise & with uint64_t
// * Support put (<<) to raw_ostream&
template <typename InsnType>
#if defined(_MSC_VER) && !defined(__clang__)
__declspec(noinline)
#endif
static std::enable_if_t<std::is_integral<InsnType>::value, InsnType>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  assert(startBit + numBits <= 64 && "Cannot support >64-bit extractions!");
  assert(startBit + numBits <= (sizeof(InsnType) * 8) &&
         "Instruction field out of bounds!");
  InsnType fieldMask;
  if (numBits == sizeof(InsnType) * 8)
    fieldMask = (InsnType)(-1LL);
  else
    fieldMask = (((InsnType)1 << numBits) - 1) << startBit;
  return (insn & fieldMask) >> startBit;
}

template <typename InsnType>
static std::enable_if_t<!std::is_integral<InsnType>::value, uint64_t>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  return insn.extractBitsAsZExtValue(numBits, startBit);
}

// Helper function for inserting bits extracted from an encoded instruction into
// a field.
template <typename InsnType>
static void insertBits(InsnType &field, InsnType bits, unsigned startBit,
                       unsigned numBits) {
  if constexpr (std::is_integral<InsnType>::value) {
    assert(startBit + numBits <= sizeof field * 8);
    (void)numBits;
    field |= (InsnType)bits << startBit;
  } else {
    field.insertBits(bits, startBit, numBits);
  }
}

static bool Check(DecodeStatus &Out, DecodeStatus In) {
  Out = static_cast<DecodeStatus>(Out & In);
  return Out != MCDisassembler::Fail;
}

static const uint8_t DecoderTableSparc32[] = {
/* 0 */       MCD::OPC_ExtractField, 30, 2,  // Inst{31-30} ...
/* 3 */       MCD::OPC_FilterValue, 0, 141, 1, // Skip to: 404
/* 7 */       MCD::OPC_ExtractField, 22, 3,  // Inst{24-22} ...
/* 10 */      MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 22
/* 14 */      MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 18 */      MCD::OPC_Decode, 174, 6, 0, // Opcode: UNIMP, DecodeIdx: 0
/* 22 */      MCD::OPC_FilterValue, 1, 93, 0, // Skip to: 119
/* 26 */      MCD::OPC_ExtractField, 19, 3,  // Inst{21-19} ...
/* 29 */      MCD::OPC_FilterValue, 0, 21, 0, // Skip to: 54
/* 33 */      MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 36 */      MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 46
/* 40 */      MCD::OPC_CheckPredicateOrFail, 0, 
/* 42 */      MCD::OPC_Decode, 237, 2, 1, // Opcode: BPICCNT, DecodeIdx: 1
/* 46 */      MCD::OPC_FilterValueOrFail, 1, 
/* 48 */      MCD::OPC_CheckPredicateOrFail, 0, 
/* 50 */      MCD::OPC_Decode, 236, 2, 1, // Opcode: BPICCANT, DecodeIdx: 1
/* 54 */      MCD::OPC_FilterValue, 1, 21, 0, // Skip to: 79
/* 58 */      MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 61 */      MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 71
/* 65 */      MCD::OPC_CheckPredicateOrFail, 0, 
/* 67 */      MCD::OPC_Decode, 234, 2, 1, // Opcode: BPICC, DecodeIdx: 1
/* 71 */      MCD::OPC_FilterValueOrFail, 1, 
/* 73 */      MCD::OPC_CheckPredicateOrFail, 0, 
/* 75 */      MCD::OPC_Decode, 235, 2, 1, // Opcode: BPICCA, DecodeIdx: 1
/* 79 */      MCD::OPC_FilterValue, 4, 17, 0, // Skip to: 100
/* 83 */      MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 86 */      MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 94
/* 90 */      MCD::OPC_Decode, 245, 2, 1, // Opcode: BPXCCNT, DecodeIdx: 1
/* 94 */      MCD::OPC_FilterValueOrFail, 1, 
/* 96 */      MCD::OPC_Decode, 244, 2, 1, // Opcode: BPXCCANT, DecodeIdx: 1
/* 100 */     MCD::OPC_FilterValueOrFail, 5, 
/* 102 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 105 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 113
/* 109 */     MCD::OPC_Decode, 242, 2, 1, // Opcode: BPXCC, DecodeIdx: 1
/* 113 */     MCD::OPC_FilterValueOrFail, 1, 
/* 115 */     MCD::OPC_Decode, 243, 2, 1, // Opcode: BPXCCA, DecodeIdx: 1
/* 119 */     MCD::OPC_FilterValue, 2, 27, 0, // Skip to: 150
/* 123 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 126 */     MCD::OPC_FilterValue, 0, 14, 0, // Skip to: 144
/* 130 */     MCD::OPC_CheckField, 25, 4, 8, 4, 0, // Skip to: 140
/* 136 */     MCD::OPC_Decode, 224, 2, 2, // Opcode: BA, DecodeIdx: 2
/* 140 */     MCD::OPC_Decode, 225, 2, 3, // Opcode: BCOND, DecodeIdx: 3
/* 144 */     MCD::OPC_FilterValueOrFail, 1, 
/* 146 */     MCD::OPC_Decode, 226, 2, 3, // Opcode: BCONDA, DecodeIdx: 3
/* 150 */     MCD::OPC_FilterValue, 3, 103, 0, // Skip to: 257
/* 154 */     MCD::OPC_ExtractField, 28, 1,  // Inst{28} ...
/* 157 */     MCD::OPC_FilterValue, 0, 43, 0, // Skip to: 204
/* 161 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 164 */     MCD::OPC_FilterValue, 0, 17, 0, // Skip to: 185
/* 168 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 171 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 179
/* 175 */     MCD::OPC_Decode, 241, 2, 4, // Opcode: BPRNT, DecodeIdx: 4
/* 179 */     MCD::OPC_FilterValueOrFail, 1, 
/* 181 */     MCD::OPC_Decode, 240, 2, 4, // Opcode: BPRANT, DecodeIdx: 4
/* 185 */     MCD::OPC_FilterValueOrFail, 1, 
/* 187 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 190 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 198
/* 194 */     MCD::OPC_Decode, 238, 2, 4, // Opcode: BPR, DecodeIdx: 4
/* 198 */     MCD::OPC_FilterValueOrFail, 1, 
/* 200 */     MCD::OPC_Decode, 239, 2, 4, // Opcode: BPRA, DecodeIdx: 4
/* 204 */     MCD::OPC_FilterValueOrFail, 1, 
/* 206 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 209 */     MCD::OPC_FilterValue, 0, 21, 0, // Skip to: 234
/* 213 */     MCD::OPC_ExtractField, 21, 1,  // Inst{21} ...
/* 216 */     MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 226
/* 220 */     MCD::OPC_CheckPredicateOrFail, 1, 
/* 222 */     MCD::OPC_Decode, 135, 3, 5, // Opcode: CWBCONDrr, DecodeIdx: 5
/* 226 */     MCD::OPC_FilterValueOrFail, 1, 
/* 228 */     MCD::OPC_CheckPredicateOrFail, 1, 
/* 230 */     MCD::OPC_Decode, 137, 3, 5, // Opcode: CXBCONDrr, DecodeIdx: 5
/* 234 */     MCD::OPC_FilterValueOrFail, 1, 
/* 236 */     MCD::OPC_ExtractField, 21, 1,  // Inst{21} ...
/* 239 */     MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 249
/* 243 */     MCD::OPC_CheckPredicateOrFail, 1, 
/* 245 */     MCD::OPC_Decode, 134, 3, 6, // Opcode: CWBCONDri, DecodeIdx: 6
/* 249 */     MCD::OPC_FilterValueOrFail, 1, 
/* 251 */     MCD::OPC_CheckPredicateOrFail, 1, 
/* 253 */     MCD::OPC_Decode, 136, 3, 6, // Opcode: CXBCONDri, DecodeIdx: 6
/* 257 */     MCD::OPC_FilterValue, 4, 20, 0, // Skip to: 281
/* 261 */     MCD::OPC_CheckField, 25, 5, 0, 10, 0, // Skip to: 277
/* 267 */     MCD::OPC_CheckField, 0, 22, 0, 4, 0, // Skip to: 277
/* 273 */     MCD::OPC_Decode, 142, 5, 7, // Opcode: NOP, DecodeIdx: 7
/* 277 */     MCD::OPC_Decode, 185, 5, 8, // Opcode: SETHIi, DecodeIdx: 8
/* 281 */     MCD::OPC_FilterValue, 5, 79, 0, // Skip to: 364
/* 285 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 288 */     MCD::OPC_FilterValue, 0, 21, 0, // Skip to: 313
/* 292 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 295 */     MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 305
/* 299 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 301 */     MCD::OPC_Decode, 233, 2, 9, // Opcode: BPFCCNT, DecodeIdx: 9
/* 305 */     MCD::OPC_FilterValueOrFail, 1, 
/* 307 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 309 */     MCD::OPC_Decode, 232, 2, 9, // Opcode: BPFCCANT, DecodeIdx: 9
/* 313 */     MCD::OPC_FilterValueOrFail, 1, 
/* 315 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 318 */     MCD::OPC_FilterValue, 0, 20, 0, // Skip to: 342
/* 322 */     MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 336
/* 326 */     MCD::OPC_CheckField, 20, 2, 0, 4, 0, // Skip to: 336
/* 332 */     MCD::OPC_Decode, 167, 3, 1, // Opcode: FBCOND_V9, DecodeIdx: 1
/* 336 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 338 */     MCD::OPC_Decode, 230, 2, 9, // Opcode: BPFCC, DecodeIdx: 9
/* 342 */     MCD::OPC_FilterValueOrFail, 1, 
/* 344 */     MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 358
/* 348 */     MCD::OPC_CheckField, 20, 2, 0, 4, 0, // Skip to: 358
/* 354 */     MCD::OPC_Decode, 166, 3, 1, // Opcode: FBCONDA_V9, DecodeIdx: 1
/* 358 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 360 */     MCD::OPC_Decode, 231, 2, 9, // Opcode: BPFCCA, DecodeIdx: 9
/* 364 */     MCD::OPC_FilterValue, 6, 17, 0, // Skip to: 385
/* 368 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 371 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 379
/* 375 */     MCD::OPC_Decode, 164, 3, 3, // Opcode: FBCOND, DecodeIdx: 3
/* 379 */     MCD::OPC_FilterValueOrFail, 1, 
/* 381 */     MCD::OPC_Decode, 165, 3, 3, // Opcode: FBCONDA, DecodeIdx: 3
/* 385 */     MCD::OPC_FilterValueOrFail, 7, 
/* 387 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 390 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 398
/* 394 */     MCD::OPC_Decode, 132, 3, 3, // Opcode: CPBCOND, DecodeIdx: 3
/* 398 */     MCD::OPC_FilterValueOrFail, 1, 
/* 400 */     MCD::OPC_Decode, 133, 3, 3, // Opcode: CPBCONDA, DecodeIdx: 3
/* 404 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 412
/* 408 */     MCD::OPC_Decode, 247, 2, 10, // Opcode: CALL, DecodeIdx: 10
/* 412 */     MCD::OPC_FilterValue, 2, 144, 16, // Skip to: 4656
/* 416 */     MCD::OPC_ExtractField, 19, 6,  // Inst{24-19} ...
/* 419 */     MCD::OPC_FilterValue, 0, 21, 0, // Skip to: 444
/* 423 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 426 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 438
/* 430 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 434 */     MCD::OPC_Decode, 209, 2, 11, // Opcode: ADDrr, DecodeIdx: 11
/* 438 */     MCD::OPC_FilterValueOrFail, 1, 
/* 440 */     MCD::OPC_Decode, 208, 2, 12, // Opcode: ADDri, DecodeIdx: 12
/* 444 */     MCD::OPC_FilterValue, 1, 21, 0, // Skip to: 469
/* 448 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 451 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 463
/* 455 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 459 */     MCD::OPC_Decode, 220, 2, 11, // Opcode: ANDrr, DecodeIdx: 11
/* 463 */     MCD::OPC_FilterValueOrFail, 1, 
/* 465 */     MCD::OPC_Decode, 219, 2, 12, // Opcode: ANDri, DecodeIdx: 12
/* 469 */     MCD::OPC_FilterValue, 2, 21, 0, // Skip to: 494
/* 473 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 476 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 488
/* 480 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 484 */     MCD::OPC_Decode, 151, 5, 11, // Opcode: ORrr, DecodeIdx: 11
/* 488 */     MCD::OPC_FilterValueOrFail, 1, 
/* 490 */     MCD::OPC_Decode, 150, 5, 12, // Opcode: ORri, DecodeIdx: 12
/* 494 */     MCD::OPC_FilterValue, 3, 21, 0, // Skip to: 519
/* 498 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 501 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 513
/* 505 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 509 */     MCD::OPC_Decode, 205, 6, 11, // Opcode: XORrr, DecodeIdx: 11
/* 513 */     MCD::OPC_FilterValueOrFail, 1, 
/* 515 */     MCD::OPC_Decode, 204, 6, 12, // Opcode: XORri, DecodeIdx: 12
/* 519 */     MCD::OPC_FilterValue, 4, 21, 0, // Skip to: 544
/* 523 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 526 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 538
/* 530 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 534 */     MCD::OPC_Decode, 133, 6, 11, // Opcode: SUBrr, DecodeIdx: 11
/* 538 */     MCD::OPC_FilterValueOrFail, 1, 
/* 540 */     MCD::OPC_Decode, 132, 6, 12, // Opcode: SUBri, DecodeIdx: 12
/* 544 */     MCD::OPC_FilterValue, 5, 21, 0, // Skip to: 569
/* 548 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 551 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 563
/* 555 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 559 */     MCD::OPC_Decode, 218, 2, 11, // Opcode: ANDNrr, DecodeIdx: 11
/* 563 */     MCD::OPC_FilterValueOrFail, 1, 
/* 565 */     MCD::OPC_Decode, 217, 2, 12, // Opcode: ANDNri, DecodeIdx: 12
/* 569 */     MCD::OPC_FilterValue, 6, 21, 0, // Skip to: 594
/* 573 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 576 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 588
/* 580 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 584 */     MCD::OPC_Decode, 149, 5, 11, // Opcode: ORNrr, DecodeIdx: 11
/* 588 */     MCD::OPC_FilterValueOrFail, 1, 
/* 590 */     MCD::OPC_Decode, 148, 5, 12, // Opcode: ORNri, DecodeIdx: 12
/* 594 */     MCD::OPC_FilterValue, 7, 21, 0, // Skip to: 619
/* 598 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 601 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 613
/* 605 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 609 */     MCD::OPC_Decode, 201, 6, 11, // Opcode: XNORrr, DecodeIdx: 11
/* 613 */     MCD::OPC_FilterValueOrFail, 1, 
/* 615 */     MCD::OPC_Decode, 200, 6, 12, // Opcode: XNORri, DecodeIdx: 12
/* 619 */     MCD::OPC_FilterValue, 8, 21, 0, // Skip to: 644
/* 623 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 626 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 638
/* 630 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 634 */     MCD::OPC_Decode, 203, 2, 11, // Opcode: ADDCrr, DecodeIdx: 11
/* 638 */     MCD::OPC_FilterValueOrFail, 1, 
/* 640 */     MCD::OPC_Decode, 202, 2, 12, // Opcode: ADDCri, DecodeIdx: 12
/* 644 */     MCD::OPC_FilterValue, 9, 21, 0, // Skip to: 669
/* 648 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 651 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 663
/* 655 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 659 */     MCD::OPC_Decode, 141, 5, 13, // Opcode: MULXrr, DecodeIdx: 13
/* 663 */     MCD::OPC_FilterValueOrFail, 1, 
/* 665 */     MCD::OPC_Decode, 140, 5, 14, // Opcode: MULXri, DecodeIdx: 14
/* 669 */     MCD::OPC_FilterValue, 10, 21, 0, // Skip to: 694
/* 673 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 676 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 688
/* 680 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 684 */     MCD::OPC_Decode, 173, 6, 11, // Opcode: UMULrr, DecodeIdx: 11
/* 688 */     MCD::OPC_FilterValueOrFail, 1, 
/* 690 */     MCD::OPC_Decode, 172, 6, 12, // Opcode: UMULri, DecodeIdx: 12
/* 694 */     MCD::OPC_FilterValue, 11, 21, 0, // Skip to: 719
/* 698 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 701 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 713
/* 705 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 709 */     MCD::OPC_Decode, 198, 5, 11, // Opcode: SMULrr, DecodeIdx: 11
/* 713 */     MCD::OPC_FilterValueOrFail, 1, 
/* 715 */     MCD::OPC_Decode, 197, 5, 12, // Opcode: SMULri, DecodeIdx: 12
/* 719 */     MCD::OPC_FilterValue, 12, 21, 0, // Skip to: 744
/* 723 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 726 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 738
/* 730 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 734 */     MCD::OPC_Decode, 129, 6, 11, // Opcode: SUBCrr, DecodeIdx: 11
/* 738 */     MCD::OPC_FilterValueOrFail, 1, 
/* 740 */     MCD::OPC_Decode, 128, 6, 12, // Opcode: SUBCri, DecodeIdx: 12
/* 744 */     MCD::OPC_FilterValue, 13, 21, 0, // Skip to: 769
/* 748 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 751 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 763
/* 755 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 759 */     MCD::OPC_Decode, 164, 6, 13, // Opcode: UDIVXrr, DecodeIdx: 13
/* 763 */     MCD::OPC_FilterValueOrFail, 1, 
/* 765 */     MCD::OPC_Decode, 163, 6, 14, // Opcode: UDIVXri, DecodeIdx: 14
/* 769 */     MCD::OPC_FilterValue, 14, 21, 0, // Skip to: 794
/* 773 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 776 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 788
/* 780 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 784 */     MCD::OPC_Decode, 166, 6, 11, // Opcode: UDIVrr, DecodeIdx: 11
/* 788 */     MCD::OPC_FilterValueOrFail, 1, 
/* 790 */     MCD::OPC_Decode, 165, 6, 12, // Opcode: UDIVri, DecodeIdx: 12
/* 794 */     MCD::OPC_FilterValue, 15, 21, 0, // Skip to: 819
/* 798 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 801 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 813
/* 805 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 809 */     MCD::OPC_Decode, 184, 5, 11, // Opcode: SDIVrr, DecodeIdx: 11
/* 813 */     MCD::OPC_FilterValueOrFail, 1, 
/* 815 */     MCD::OPC_Decode, 183, 5, 12, // Opcode: SDIVri, DecodeIdx: 12
/* 819 */     MCD::OPC_FilterValue, 16, 21, 0, // Skip to: 844
/* 823 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 826 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 838
/* 830 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 834 */     MCD::OPC_Decode, 201, 2, 11, // Opcode: ADDCCrr, DecodeIdx: 11
/* 838 */     MCD::OPC_FilterValueOrFail, 1, 
/* 840 */     MCD::OPC_Decode, 200, 2, 12, // Opcode: ADDCCri, DecodeIdx: 12
/* 844 */     MCD::OPC_FilterValue, 17, 21, 0, // Skip to: 869
/* 848 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 851 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 863
/* 855 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 859 */     MCD::OPC_Decode, 214, 2, 11, // Opcode: ANDCCrr, DecodeIdx: 11
/* 863 */     MCD::OPC_FilterValueOrFail, 1, 
/* 865 */     MCD::OPC_Decode, 213, 2, 12, // Opcode: ANDCCri, DecodeIdx: 12
/* 869 */     MCD::OPC_FilterValue, 18, 21, 0, // Skip to: 894
/* 873 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 876 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 888
/* 880 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 884 */     MCD::OPC_Decode, 145, 5, 11, // Opcode: ORCCrr, DecodeIdx: 11
/* 888 */     MCD::OPC_FilterValueOrFail, 1, 
/* 890 */     MCD::OPC_Decode, 144, 5, 12, // Opcode: ORCCri, DecodeIdx: 12
/* 894 */     MCD::OPC_FilterValue, 19, 21, 0, // Skip to: 919
/* 898 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 901 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 913
/* 905 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 909 */     MCD::OPC_Decode, 203, 6, 11, // Opcode: XORCCrr, DecodeIdx: 11
/* 913 */     MCD::OPC_FilterValueOrFail, 1, 
/* 915 */     MCD::OPC_Decode, 202, 6, 12, // Opcode: XORCCri, DecodeIdx: 12
/* 919 */     MCD::OPC_FilterValue, 20, 21, 0, // Skip to: 944
/* 923 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 926 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 938
/* 930 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 934 */     MCD::OPC_Decode, 255, 5, 11, // Opcode: SUBCCrr, DecodeIdx: 11
/* 938 */     MCD::OPC_FilterValueOrFail, 1, 
/* 940 */     MCD::OPC_Decode, 254, 5, 12, // Opcode: SUBCCri, DecodeIdx: 12
/* 944 */     MCD::OPC_FilterValue, 21, 21, 0, // Skip to: 969
/* 948 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 951 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 963
/* 955 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 959 */     MCD::OPC_Decode, 216, 2, 11, // Opcode: ANDNCCrr, DecodeIdx: 11
/* 963 */     MCD::OPC_FilterValueOrFail, 1, 
/* 965 */     MCD::OPC_Decode, 215, 2, 12, // Opcode: ANDNCCri, DecodeIdx: 12
/* 969 */     MCD::OPC_FilterValue, 22, 21, 0, // Skip to: 994
/* 973 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 976 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 988
/* 980 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 984 */     MCD::OPC_Decode, 147, 5, 11, // Opcode: ORNCCrr, DecodeIdx: 11
/* 988 */     MCD::OPC_FilterValueOrFail, 1, 
/* 990 */     MCD::OPC_Decode, 146, 5, 12, // Opcode: ORNCCri, DecodeIdx: 12
/* 994 */     MCD::OPC_FilterValue, 23, 21, 0, // Skip to: 1019
/* 998 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1001 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1013
/* 1005 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 1009 */    MCD::OPC_Decode, 199, 6, 11, // Opcode: XNORCCrr, DecodeIdx: 11
/* 1013 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1015 */    MCD::OPC_Decode, 198, 6, 12, // Opcode: XNORCCri, DecodeIdx: 12
/* 1019 */    MCD::OPC_FilterValue, 24, 21, 0, // Skip to: 1044
/* 1023 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1026 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1038
/* 1030 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 1034 */    MCD::OPC_Decode, 205, 2, 11, // Opcode: ADDErr, DecodeIdx: 11
/* 1038 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1040 */    MCD::OPC_Decode, 204, 2, 12, // Opcode: ADDEri, DecodeIdx: 12
/* 1044 */    MCD::OPC_FilterValue, 26, 21, 0, // Skip to: 1069
/* 1048 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1051 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1063
/* 1055 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 1059 */    MCD::OPC_Decode, 170, 6, 11, // Opcode: UMULCCrr, DecodeIdx: 11
/* 1063 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1065 */    MCD::OPC_Decode, 169, 6, 12, // Opcode: UMULCCri, DecodeIdx: 12
/* 1069 */    MCD::OPC_FilterValue, 27, 21, 0, // Skip to: 1094
/* 1073 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1076 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1088
/* 1080 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 1084 */    MCD::OPC_Decode, 196, 5, 11, // Opcode: SMULCCrr, DecodeIdx: 11
/* 1088 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1090 */    MCD::OPC_Decode, 195, 5, 12, // Opcode: SMULCCri, DecodeIdx: 12
/* 1094 */    MCD::OPC_FilterValue, 28, 21, 0, // Skip to: 1119
/* 1098 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1101 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1113
/* 1105 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 1109 */    MCD::OPC_Decode, 131, 6, 11, // Opcode: SUBErr, DecodeIdx: 11
/* 1113 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1115 */    MCD::OPC_Decode, 130, 6, 12, // Opcode: SUBEri, DecodeIdx: 12
/* 1119 */    MCD::OPC_FilterValue, 30, 21, 0, // Skip to: 1144
/* 1123 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1126 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1138
/* 1130 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 1134 */    MCD::OPC_Decode, 162, 6, 11, // Opcode: UDIVCCrr, DecodeIdx: 11
/* 1138 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1140 */    MCD::OPC_Decode, 161, 6, 12, // Opcode: UDIVCCri, DecodeIdx: 12
/* 1144 */    MCD::OPC_FilterValue, 31, 21, 0, // Skip to: 1169
/* 1148 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1151 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1163
/* 1155 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 1159 */    MCD::OPC_Decode, 180, 5, 11, // Opcode: SDIVCCrr, DecodeIdx: 11
/* 1163 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1165 */    MCD::OPC_Decode, 179, 5, 12, // Opcode: SDIVCCri, DecodeIdx: 12
/* 1169 */    MCD::OPC_FilterValue, 32, 21, 0, // Skip to: 1194
/* 1173 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1176 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1188
/* 1180 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 1184 */    MCD::OPC_Decode, 144, 6, 11, // Opcode: TADDCCrr, DecodeIdx: 11
/* 1188 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1190 */    MCD::OPC_Decode, 143, 6, 12, // Opcode: TADDCCri, DecodeIdx: 12
/* 1194 */    MCD::OPC_FilterValue, 33, 21, 0, // Skip to: 1219
/* 1198 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1201 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1213
/* 1205 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 1209 */    MCD::OPC_Decode, 158, 6, 11, // Opcode: TSUBCCrr, DecodeIdx: 11
/* 1213 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1215 */    MCD::OPC_Decode, 157, 6, 12, // Opcode: TSUBCCri, DecodeIdx: 12
/* 1219 */    MCD::OPC_FilterValue, 34, 21, 0, // Skip to: 1244
/* 1223 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1226 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1238
/* 1230 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 1234 */    MCD::OPC_Decode, 142, 6, 11, // Opcode: TADDCCTVrr, DecodeIdx: 11
/* 1238 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1240 */    MCD::OPC_Decode, 141, 6, 12, // Opcode: TADDCCTVri, DecodeIdx: 12
/* 1244 */    MCD::OPC_FilterValue, 35, 21, 0, // Skip to: 1269
/* 1248 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1251 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1263
/* 1255 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 1259 */    MCD::OPC_Decode, 156, 6, 11, // Opcode: TSUBCCTVrr, DecodeIdx: 11
/* 1263 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1265 */    MCD::OPC_Decode, 155, 6, 12, // Opcode: TSUBCCTVri, DecodeIdx: 12
/* 1269 */    MCD::OPC_FilterValue, 36, 21, 0, // Skip to: 1294
/* 1273 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1276 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1288
/* 1280 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 1284 */    MCD::OPC_Decode, 139, 5, 11, // Opcode: MULSCCrr, DecodeIdx: 11
/* 1288 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1290 */    MCD::OPC_Decode, 138, 5, 12, // Opcode: MULSCCri, DecodeIdx: 12
/* 1294 */    MCD::OPC_FilterValue, 37, 33, 0, // Skip to: 1331
/* 1298 */    MCD::OPC_ExtractField, 12, 2,  // Inst{13-12} ...
/* 1301 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1309
/* 1305 */    MCD::OPC_Decode, 192, 5, 11, // Opcode: SLLrr, DecodeIdx: 11
/* 1309 */    MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 1317
/* 1313 */    MCD::OPC_Decode, 190, 5, 15, // Opcode: SLLXrr, DecodeIdx: 15
/* 1317 */    MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 1325
/* 1321 */    MCD::OPC_Decode, 191, 5, 16, // Opcode: SLLri, DecodeIdx: 16
/* 1325 */    MCD::OPC_FilterValueOrFail, 3, 
/* 1327 */    MCD::OPC_Decode, 189, 5, 17, // Opcode: SLLXri, DecodeIdx: 17
/* 1331 */    MCD::OPC_FilterValue, 38, 33, 0, // Skip to: 1368
/* 1335 */    MCD::OPC_ExtractField, 12, 2,  // Inst{13-12} ...
/* 1338 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1346
/* 1342 */    MCD::OPC_Decode, 206, 5, 11, // Opcode: SRLrr, DecodeIdx: 11
/* 1346 */    MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 1354
/* 1350 */    MCD::OPC_Decode, 204, 5, 15, // Opcode: SRLXrr, DecodeIdx: 15
/* 1354 */    MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 1362
/* 1358 */    MCD::OPC_Decode, 205, 5, 16, // Opcode: SRLri, DecodeIdx: 16
/* 1362 */    MCD::OPC_FilterValueOrFail, 3, 
/* 1364 */    MCD::OPC_Decode, 203, 5, 17, // Opcode: SRLXri, DecodeIdx: 17
/* 1368 */    MCD::OPC_FilterValue, 39, 33, 0, // Skip to: 1405
/* 1372 */    MCD::OPC_ExtractField, 12, 2,  // Inst{13-12} ...
/* 1375 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1383
/* 1379 */    MCD::OPC_Decode, 202, 5, 11, // Opcode: SRArr, DecodeIdx: 11
/* 1383 */    MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 1391
/* 1387 */    MCD::OPC_Decode, 200, 5, 15, // Opcode: SRAXrr, DecodeIdx: 15
/* 1391 */    MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 1399
/* 1395 */    MCD::OPC_Decode, 201, 5, 16, // Opcode: SRAri, DecodeIdx: 16
/* 1399 */    MCD::OPC_FilterValueOrFail, 3, 
/* 1401 */    MCD::OPC_Decode, 199, 5, 17, // Opcode: SRAXri, DecodeIdx: 17
/* 1405 */    MCD::OPC_FilterValue, 40, 48, 0, // Skip to: 1457
/* 1409 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1412 */    MCD::OPC_FilterValue, 0, 25, 0, // Skip to: 1441
/* 1416 */    MCD::OPC_ExtractField, 0, 13,  // Inst{12-0} ...
/* 1419 */    MCD::OPC_FilterValueOrFail, 0, 
/* 1421 */    MCD::OPC_CheckField, 25, 5, 0, 10, 0, // Skip to: 1437
/* 1427 */    MCD::OPC_CheckField, 14, 5, 15, 4, 0, // Skip to: 1437
/* 1433 */    MCD::OPC_Decode, 209, 5, 7, // Opcode: STBAR, DecodeIdx: 7
/* 1437 */    MCD::OPC_Decode, 162, 5, 18, // Opcode: RDASR, DecodeIdx: 18
/* 1441 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1443 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 1445 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 1449 */    MCD::OPC_CheckFieldOrFail, 14, 5, 15, 
/* 1453 */    MCD::OPC_Decode, 252, 4, 19, // Opcode: MEMBARi, DecodeIdx: 19
/* 1457 */    MCD::OPC_FilterValue, 41, 8, 0, // Skip to: 1469
/* 1461 */    MCD::OPC_CheckFieldOrFail, 0, 19, 0, 
/* 1465 */    MCD::OPC_Decode, 165, 5, 20, // Opcode: RDPSR, DecodeIdx: 20
/* 1469 */    MCD::OPC_FilterValue, 42, 34, 0, // Skip to: 1507
/* 1473 */    MCD::OPC_ExtractField, 0, 14,  // Inst{13-0} ...
/* 1476 */    MCD::OPC_FilterValueOrFail, 0, 
/* 1478 */    MCD::OPC_ExtractField, 14, 5,  // Inst{18-14} ...
/* 1481 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1489
/* 1485 */    MCD::OPC_Decode, 167, 5, 20, // Opcode: RDWIM, DecodeIdx: 20
/* 1489 */    MCD::OPC_FilterValue, 15, 8, 0, // Skip to: 1501
/* 1493 */    MCD::OPC_CheckPredicate, 0, 4, 0, // Skip to: 1501
/* 1497 */    MCD::OPC_Decode, 163, 5, 20, // Opcode: RDFQ, DecodeIdx: 20
/* 1501 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 1503 */    MCD::OPC_Decode, 164, 5, 21, // Opcode: RDPR, DecodeIdx: 21
/* 1507 */    MCD::OPC_FilterValue, 43, 23, 0, // Skip to: 1534
/* 1511 */    MCD::OPC_ExtractField, 0, 19,  // Inst{18-0} ...
/* 1514 */    MCD::OPC_FilterValueOrFail, 0, 
/* 1516 */    MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 1530
/* 1520 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, // Skip to: 1530
/* 1526 */    MCD::OPC_Decode, 202, 3, 7, // Opcode: FLUSHW, DecodeIdx: 7
/* 1530 */    MCD::OPC_Decode, 166, 5, 20, // Opcode: RDTBR, DecodeIdx: 20
/* 1534 */    MCD::OPC_FilterValue, 44, 105, 0, // Skip to: 1643
/* 1538 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1541 */    MCD::OPC_FilterValue, 0, 48, 0, // Skip to: 1593
/* 1545 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 1548 */    MCD::OPC_FilterValue, 0, 20, 0, // Skip to: 1572
/* 1552 */    MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 1566
/* 1556 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, // Skip to: 1566
/* 1562 */    MCD::OPC_Decode, 255, 4, 22, // Opcode: MOVFCCrr, DecodeIdx: 22
/* 1566 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 1568 */    MCD::OPC_Decode, 185, 6, 23, // Opcode: V9MOVFCCrr, DecodeIdx: 23
/* 1572 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1574 */    MCD::OPC_ExtractField, 11, 2,  // Inst{12-11} ...
/* 1577 */    MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 1587
/* 1581 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 1583 */    MCD::OPC_Decode, 129, 5, 22, // Opcode: MOVICCrr, DecodeIdx: 22
/* 1587 */    MCD::OPC_FilterValueOrFail, 2, 
/* 1589 */    MCD::OPC_Decode, 136, 5, 22, // Opcode: MOVXCCrr, DecodeIdx: 22
/* 1593 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1595 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 1598 */    MCD::OPC_FilterValue, 0, 20, 0, // Skip to: 1622
/* 1602 */    MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 1616
/* 1606 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, // Skip to: 1616
/* 1612 */    MCD::OPC_Decode, 254, 4, 24, // Opcode: MOVFCCri, DecodeIdx: 24
/* 1616 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 1618 */    MCD::OPC_Decode, 184, 6, 25, // Opcode: V9MOVFCCri, DecodeIdx: 25
/* 1622 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1624 */    MCD::OPC_ExtractField, 11, 2,  // Inst{12-11} ...
/* 1627 */    MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 1637
/* 1631 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 1633 */    MCD::OPC_Decode, 128, 5, 24, // Opcode: MOVICCri, DecodeIdx: 24
/* 1637 */    MCD::OPC_FilterValueOrFail, 2, 
/* 1639 */    MCD::OPC_Decode, 135, 5, 24, // Opcode: MOVXCCri, DecodeIdx: 24
/* 1643 */    MCD::OPC_FilterValue, 45, 21, 0, // Skip to: 1668
/* 1647 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1650 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1662
/* 1654 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 1658 */    MCD::OPC_Decode, 182, 5, 13, // Opcode: SDIVXrr, DecodeIdx: 13
/* 1662 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1664 */    MCD::OPC_Decode, 181, 5, 14, // Opcode: SDIVXri, DecodeIdx: 14
/* 1668 */    MCD::OPC_FilterValue, 46, 10, 0, // Skip to: 1682
/* 1672 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 1674 */    MCD::OPC_CheckFieldOrFail, 5, 14, 0, 
/* 1678 */    MCD::OPC_Decode, 155, 5, 26, // Opcode: POPCrr, DecodeIdx: 26
/* 1682 */    MCD::OPC_FilterValue, 47, 21, 0, // Skip to: 1707
/* 1686 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1689 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1701
/* 1693 */    MCD::OPC_CheckFieldOrFail, 5, 5, 0, 
/* 1697 */    MCD::OPC_Decode, 131, 5, 27, // Opcode: MOVRrr, DecodeIdx: 27
/* 1701 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1703 */    MCD::OPC_Decode, 130, 5, 28, // Opcode: MOVRri, DecodeIdx: 28
/* 1707 */    MCD::OPC_FilterValue, 48, 41, 0, // Skip to: 1752
/* 1711 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1714 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1726
/* 1718 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 1722 */    MCD::OPC_Decode, 187, 6, 29, // Opcode: WRASRrr, DecodeIdx: 29
/* 1726 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1728 */    MCD::OPC_CheckPredicate, 0, 16, 0, // Skip to: 1748
/* 1732 */    MCD::OPC_CheckField, 25, 5, 15, 10, 0, // Skip to: 1748
/* 1738 */    MCD::OPC_CheckField, 14, 5, 0, 4, 0, // Skip to: 1748
/* 1744 */    MCD::OPC_Decode, 188, 5, 30, // Opcode: SIR, DecodeIdx: 30
/* 1748 */    MCD::OPC_Decode, 186, 6, 31, // Opcode: WRASRri, DecodeIdx: 31
/* 1752 */    MCD::OPC_FilterValue, 49, 153, 0, // Skip to: 1909
/* 1756 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 1759 */    MCD::OPC_FilterValue, 0, 42, 0, // Skip to: 1805
/* 1763 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1766 */    MCD::OPC_FilterValue, 0, 29, 0, // Skip to: 1799
/* 1770 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 1773 */    MCD::OPC_FilterValueOrFail, 0, 
/* 1775 */    MCD::OPC_CheckPredicate, 0, 16, 0, // Skip to: 1795
/* 1779 */    MCD::OPC_CheckField, 14, 5, 0, 10, 0, // Skip to: 1795
/* 1785 */    MCD::OPC_CheckField, 0, 5, 0, 4, 0, // Skip to: 1795
/* 1791 */    MCD::OPC_Decode, 176, 5, 7, // Opcode: SAVED, DecodeIdx: 7
/* 1795 */    MCD::OPC_Decode, 191, 6, 32, // Opcode: WRPSRrr, DecodeIdx: 32
/* 1799 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1801 */    MCD::OPC_Decode, 190, 6, 33, // Opcode: WRPSRri, DecodeIdx: 33
/* 1805 */    MCD::OPC_FilterValue, 1, 46, 0, // Skip to: 1855
/* 1809 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1812 */    MCD::OPC_FilterValue, 0, 31, 0, // Skip to: 1847
/* 1816 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 1819 */    MCD::OPC_FilterValueOrFail, 0, 
/* 1821 */    MCD::OPC_CheckPredicate, 0, 16, 0, // Skip to: 1841
/* 1825 */    MCD::OPC_CheckField, 14, 5, 0, 10, 0, // Skip to: 1841
/* 1831 */    MCD::OPC_CheckField, 0, 5, 0, 4, 0, // Skip to: 1841
/* 1837 */    MCD::OPC_Decode, 168, 5, 7, // Opcode: RESTORED, DecodeIdx: 7
/* 1841 */    MCD::OPC_CheckPredicateOrFail, 2, 
/* 1843 */    MCD::OPC_Decode, 161, 5, 32, // Opcode: PWRPSRrr, DecodeIdx: 32
/* 1847 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1849 */    MCD::OPC_CheckPredicateOrFail, 2, 
/* 1851 */    MCD::OPC_Decode, 160, 5, 33, // Opcode: PWRPSRri, DecodeIdx: 33
/* 1855 */    MCD::OPC_FilterValue, 2, 10, 0, // Skip to: 1869
/* 1859 */    MCD::OPC_CheckPredicateOrFail, 3, 
/* 1861 */    MCD::OPC_CheckFieldOrFail, 0, 19, 0, 
/* 1865 */    MCD::OPC_Decode, 212, 2, 7, // Opcode: ALLCLEAN, DecodeIdx: 7
/* 1869 */    MCD::OPC_FilterValue, 3, 10, 0, // Skip to: 1883
/* 1873 */    MCD::OPC_CheckPredicateOrFail, 3, 
/* 1875 */    MCD::OPC_CheckFieldOrFail, 0, 19, 0, 
/* 1879 */    MCD::OPC_Decode, 152, 5, 7, // Opcode: OTHERW, DecodeIdx: 7
/* 1883 */    MCD::OPC_FilterValue, 4, 10, 0, // Skip to: 1897
/* 1887 */    MCD::OPC_CheckPredicateOrFail, 3, 
/* 1889 */    MCD::OPC_CheckFieldOrFail, 0, 19, 0, 
/* 1893 */    MCD::OPC_Decode, 143, 5, 7, // Opcode: NORMALW, DecodeIdx: 7
/* 1897 */    MCD::OPC_FilterValueOrFail, 5, 
/* 1899 */    MCD::OPC_CheckPredicateOrFail, 3, 
/* 1901 */    MCD::OPC_CheckFieldOrFail, 0, 19, 0, 
/* 1905 */    MCD::OPC_Decode, 190, 4, 7, // Opcode: INVALW, DecodeIdx: 7
/* 1909 */    MCD::OPC_FilterValue, 50, 46, 0, // Skip to: 1959
/* 1913 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1916 */    MCD::OPC_FilterValue, 0, 21, 0, // Skip to: 1941
/* 1920 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 1923 */    MCD::OPC_FilterValueOrFail, 0, 
/* 1925 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, // Skip to: 1935
/* 1931 */    MCD::OPC_Decode, 195, 6, 32, // Opcode: WRWIMrr, DecodeIdx: 32
/* 1935 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 1937 */    MCD::OPC_Decode, 189, 6, 34, // Opcode: WRPRrr, DecodeIdx: 34
/* 1941 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1943 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, // Skip to: 1953
/* 1949 */    MCD::OPC_Decode, 194, 6, 33, // Opcode: WRWIMri, DecodeIdx: 33
/* 1953 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 1955 */    MCD::OPC_Decode, 188, 6, 35, // Opcode: WRPRri, DecodeIdx: 35
/* 1959 */    MCD::OPC_FilterValue, 51, 29, 0, // Skip to: 1992
/* 1963 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1966 */    MCD::OPC_FilterValue, 0, 12, 0, // Skip to: 1982
/* 1970 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 1974 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 1978 */    MCD::OPC_Decode, 193, 6, 32, // Opcode: WRTBRrr, DecodeIdx: 32
/* 1982 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1984 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 1988 */    MCD::OPC_Decode, 192, 6, 33, // Opcode: WRTBRri, DecodeIdx: 33
/* 1992 */    MCD::OPC_FilterValue, 52, 101, 2, // Skip to: 2609
/* 1996 */    MCD::OPC_ExtractField, 5, 9,  // Inst{13-5} ...
/* 1999 */    MCD::OPC_FilterValue, 1, 8, 0, // Skip to: 2011
/* 2003 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2007 */    MCD::OPC_Decode, 219, 3, 36, // Opcode: FMOVS, DecodeIdx: 36
/* 2011 */    MCD::OPC_FilterValue, 2, 10, 0, // Skip to: 2025
/* 2015 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2017 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2021 */    MCD::OPC_Decode, 208, 3, 37, // Opcode: FMOVD, DecodeIdx: 37
/* 2025 */    MCD::OPC_FilterValue, 3, 10, 0, // Skip to: 2039
/* 2029 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2031 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2035 */    MCD::OPC_Decode, 212, 3, 38, // Opcode: FMOVQ, DecodeIdx: 38
/* 2039 */    MCD::OPC_FilterValue, 5, 8, 0, // Skip to: 2051
/* 2043 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2047 */    MCD::OPC_Decode, 241, 3, 36, // Opcode: FNEGS, DecodeIdx: 36
/* 2051 */    MCD::OPC_FilterValue, 6, 10, 0, // Skip to: 2065
/* 2055 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2057 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2061 */    MCD::OPC_Decode, 239, 3, 37, // Opcode: FNEGD, DecodeIdx: 37
/* 2065 */    MCD::OPC_FilterValue, 7, 10, 0, // Skip to: 2079
/* 2069 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2071 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2075 */    MCD::OPC_Decode, 240, 3, 38, // Opcode: FNEGQ, DecodeIdx: 38
/* 2079 */    MCD::OPC_FilterValue, 9, 8, 0, // Skip to: 2091
/* 2083 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2087 */    MCD::OPC_Decode, 153, 3, 36, // Opcode: FABSS, DecodeIdx: 36
/* 2091 */    MCD::OPC_FilterValue, 10, 10, 0, // Skip to: 2105
/* 2095 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2097 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2101 */    MCD::OPC_Decode, 151, 3, 37, // Opcode: FABSD, DecodeIdx: 37
/* 2105 */    MCD::OPC_FilterValue, 11, 10, 0, // Skip to: 2119
/* 2109 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2111 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2115 */    MCD::OPC_Decode, 152, 3, 38, // Opcode: FABSQ, DecodeIdx: 38
/* 2119 */    MCD::OPC_FilterValue, 41, 8, 0, // Skip to: 2131
/* 2123 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2127 */    MCD::OPC_Decode, 163, 4, 36, // Opcode: FSQRTS, DecodeIdx: 36
/* 2131 */    MCD::OPC_FilterValue, 42, 8, 0, // Skip to: 2143
/* 2135 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2139 */    MCD::OPC_Decode, 161, 4, 37, // Opcode: FSQRTD, DecodeIdx: 37
/* 2143 */    MCD::OPC_FilterValue, 43, 8, 0, // Skip to: 2155
/* 2147 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2151 */    MCD::OPC_Decode, 162, 4, 38, // Opcode: FSQRTQ, DecodeIdx: 38
/* 2155 */    MCD::OPC_FilterValue, 65, 4, 0, // Skip to: 2163
/* 2159 */    MCD::OPC_Decode, 156, 3, 39, // Opcode: FADDS, DecodeIdx: 39
/* 2163 */    MCD::OPC_FilterValue, 66, 4, 0, // Skip to: 2171
/* 2167 */    MCD::OPC_Decode, 154, 3, 40, // Opcode: FADDD, DecodeIdx: 40
/* 2171 */    MCD::OPC_FilterValue, 67, 4, 0, // Skip to: 2179
/* 2175 */    MCD::OPC_Decode, 155, 3, 41, // Opcode: FADDQ, DecodeIdx: 41
/* 2179 */    MCD::OPC_FilterValue, 69, 4, 0, // Skip to: 2187
/* 2183 */    MCD::OPC_Decode, 178, 4, 39, // Opcode: FSUBS, DecodeIdx: 39
/* 2187 */    MCD::OPC_FilterValue, 70, 4, 0, // Skip to: 2195
/* 2191 */    MCD::OPC_Decode, 176, 4, 40, // Opcode: FSUBD, DecodeIdx: 40
/* 2195 */    MCD::OPC_FilterValue, 71, 4, 0, // Skip to: 2203
/* 2199 */    MCD::OPC_Decode, 177, 4, 41, // Opcode: FSUBQ, DecodeIdx: 41
/* 2203 */    MCD::OPC_FilterValue, 73, 4, 0, // Skip to: 2211
/* 2207 */    MCD::OPC_Decode, 234, 3, 39, // Opcode: FMULS, DecodeIdx: 39
/* 2211 */    MCD::OPC_FilterValue, 74, 4, 0, // Skip to: 2219
/* 2215 */    MCD::OPC_Decode, 230, 3, 40, // Opcode: FMULD, DecodeIdx: 40
/* 2219 */    MCD::OPC_FilterValue, 75, 4, 0, // Skip to: 2227
/* 2223 */    MCD::OPC_Decode, 233, 3, 41, // Opcode: FMULQ, DecodeIdx: 41
/* 2227 */    MCD::OPC_FilterValue, 77, 4, 0, // Skip to: 2235
/* 2231 */    MCD::OPC_Decode, 185, 3, 39, // Opcode: FDIVS, DecodeIdx: 39
/* 2235 */    MCD::OPC_FilterValue, 78, 4, 0, // Skip to: 2243
/* 2239 */    MCD::OPC_Decode, 183, 3, 40, // Opcode: FDIVD, DecodeIdx: 40
/* 2243 */    MCD::OPC_FilterValue, 79, 4, 0, // Skip to: 2251
/* 2247 */    MCD::OPC_Decode, 184, 3, 41, // Opcode: FDIVQ, DecodeIdx: 41
/* 2251 */    MCD::OPC_FilterValue, 81, 6, 0, // Skip to: 2261
/* 2255 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 2257 */    MCD::OPC_Decode, 236, 3, 39, // Opcode: FNADDS, DecodeIdx: 39
/* 2261 */    MCD::OPC_FilterValue, 82, 6, 0, // Skip to: 2271
/* 2265 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 2267 */    MCD::OPC_Decode, 235, 3, 40, // Opcode: FNADDD, DecodeIdx: 40
/* 2271 */    MCD::OPC_FilterValue, 89, 6, 0, // Skip to: 2281
/* 2275 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 2277 */    MCD::OPC_Decode, 249, 3, 39, // Opcode: FNMULS, DecodeIdx: 39
/* 2281 */    MCD::OPC_FilterValue, 90, 6, 0, // Skip to: 2291
/* 2285 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 2287 */    MCD::OPC_Decode, 248, 3, 40, // Opcode: FNMULD, DecodeIdx: 40
/* 2291 */    MCD::OPC_FilterValue, 97, 6, 0, // Skip to: 2301
/* 2295 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 2297 */    MCD::OPC_Decode, 193, 3, 39, // Opcode: FHADDS, DecodeIdx: 39
/* 2301 */    MCD::OPC_FilterValue, 98, 6, 0, // Skip to: 2311
/* 2305 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 2307 */    MCD::OPC_Decode, 192, 3, 40, // Opcode: FHADDD, DecodeIdx: 40
/* 2311 */    MCD::OPC_FilterValue, 101, 6, 0, // Skip to: 2321
/* 2315 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 2317 */    MCD::OPC_Decode, 195, 3, 39, // Opcode: FHSUBS, DecodeIdx: 39
/* 2321 */    MCD::OPC_FilterValue, 102, 6, 0, // Skip to: 2331
/* 2325 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 2327 */    MCD::OPC_Decode, 194, 3, 40, // Opcode: FHSUBD, DecodeIdx: 40
/* 2331 */    MCD::OPC_FilterValue, 105, 4, 0, // Skip to: 2339
/* 2335 */    MCD::OPC_Decode, 160, 4, 42, // Opcode: FSMULD, DecodeIdx: 42
/* 2339 */    MCD::OPC_FilterValue, 110, 4, 0, // Skip to: 2347
/* 2343 */    MCD::OPC_Decode, 186, 3, 43, // Opcode: FDMULQ, DecodeIdx: 43
/* 2347 */    MCD::OPC_FilterValue, 113, 6, 0, // Skip to: 2357
/* 2351 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 2353 */    MCD::OPC_Decode, 243, 3, 39, // Opcode: FNHADDS, DecodeIdx: 39
/* 2357 */    MCD::OPC_FilterValue, 114, 6, 0, // Skip to: 2367
/* 2361 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 2363 */    MCD::OPC_Decode, 242, 3, 40, // Opcode: FNHADDD, DecodeIdx: 40
/* 2367 */    MCD::OPC_FilterValue, 121, 6, 0, // Skip to: 2377
/* 2371 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 2373 */    MCD::OPC_Decode, 128, 4, 42, // Opcode: FNSMULD, DecodeIdx: 42
/* 2377 */    MCD::OPC_FilterValue, 129, 1, 8, 0, // Skip to: 2390
/* 2382 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2386 */    MCD::OPC_Decode, 175, 4, 44, // Opcode: FSTOX, DecodeIdx: 44
/* 2390 */    MCD::OPC_FilterValue, 130, 1, 8, 0, // Skip to: 2403
/* 2395 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2399 */    MCD::OPC_Decode, 190, 3, 37, // Opcode: FDTOX, DecodeIdx: 37
/* 2403 */    MCD::OPC_FilterValue, 131, 1, 8, 0, // Skip to: 2416
/* 2408 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2412 */    MCD::OPC_Decode, 155, 4, 45, // Opcode: FQTOX, DecodeIdx: 45
/* 2416 */    MCD::OPC_FilterValue, 132, 1, 8, 0, // Skip to: 2429
/* 2421 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2425 */    MCD::OPC_Decode, 185, 4, 46, // Opcode: FXTOS, DecodeIdx: 46
/* 2429 */    MCD::OPC_FilterValue, 136, 1, 8, 0, // Skip to: 2442
/* 2434 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2438 */    MCD::OPC_Decode, 183, 4, 37, // Opcode: FXTOD, DecodeIdx: 37
/* 2442 */    MCD::OPC_FilterValue, 140, 1, 8, 0, // Skip to: 2455
/* 2447 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2451 */    MCD::OPC_Decode, 184, 4, 47, // Opcode: FXTOQ, DecodeIdx: 47
/* 2455 */    MCD::OPC_FilterValue, 196, 1, 8, 0, // Skip to: 2468
/* 2460 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2464 */    MCD::OPC_Decode, 198, 3, 36, // Opcode: FITOS, DecodeIdx: 36
/* 2468 */    MCD::OPC_FilterValue, 198, 1, 8, 0, // Skip to: 2481
/* 2473 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2477 */    MCD::OPC_Decode, 189, 3, 46, // Opcode: FDTOS, DecodeIdx: 46
/* 2481 */    MCD::OPC_FilterValue, 199, 1, 8, 0, // Skip to: 2494
/* 2486 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2490 */    MCD::OPC_Decode, 154, 4, 48, // Opcode: FQTOS, DecodeIdx: 48
/* 2494 */    MCD::OPC_FilterValue, 200, 1, 8, 0, // Skip to: 2507
/* 2499 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2503 */    MCD::OPC_Decode, 196, 3, 44, // Opcode: FITOD, DecodeIdx: 44
/* 2507 */    MCD::OPC_FilterValue, 201, 1, 8, 0, // Skip to: 2520
/* 2512 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2516 */    MCD::OPC_Decode, 172, 4, 44, // Opcode: FSTOD, DecodeIdx: 44
/* 2520 */    MCD::OPC_FilterValue, 203, 1, 8, 0, // Skip to: 2533
/* 2525 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2529 */    MCD::OPC_Decode, 152, 4, 45, // Opcode: FQTOD, DecodeIdx: 45
/* 2533 */    MCD::OPC_FilterValue, 204, 1, 8, 0, // Skip to: 2546
/* 2538 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2542 */    MCD::OPC_Decode, 197, 3, 49, // Opcode: FITOQ, DecodeIdx: 49
/* 2546 */    MCD::OPC_FilterValue, 205, 1, 8, 0, // Skip to: 2559
/* 2551 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2555 */    MCD::OPC_Decode, 174, 4, 49, // Opcode: FSTOQ, DecodeIdx: 49
/* 2559 */    MCD::OPC_FilterValue, 206, 1, 8, 0, // Skip to: 2572
/* 2564 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2568 */    MCD::OPC_Decode, 188, 3, 47, // Opcode: FDTOQ, DecodeIdx: 47
/* 2572 */    MCD::OPC_FilterValue, 209, 1, 8, 0, // Skip to: 2585
/* 2577 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2581 */    MCD::OPC_Decode, 173, 4, 36, // Opcode: FSTOI, DecodeIdx: 36
/* 2585 */    MCD::OPC_FilterValue, 210, 1, 8, 0, // Skip to: 2598
/* 2590 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2594 */    MCD::OPC_Decode, 187, 3, 46, // Opcode: FDTOI, DecodeIdx: 46
/* 2598 */    MCD::OPC_FilterValueOrFail, 211, 1, 
/* 2601 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2605 */    MCD::OPC_Decode, 153, 4, 48, // Opcode: FQTOI, DecodeIdx: 48
/* 2609 */    MCD::OPC_FilterValue, 53, 63, 1, // Skip to: 2932
/* 2613 */    MCD::OPC_ExtractField, 5, 5,  // Inst{9-5} ...
/* 2616 */    MCD::OPC_FilterValue, 1, 66, 0, // Skip to: 2686
/* 2620 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2623 */    MCD::OPC_FilterValue, 0, 30, 0, // Skip to: 2657
/* 2627 */    MCD::OPC_ExtractField, 10, 1,  // Inst{10} ...
/* 2630 */    MCD::OPC_FilterValueOrFail, 0, 
/* 2632 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 2635 */    MCD::OPC_FilterValueOrFail, 0, 
/* 2637 */    MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 2651
/* 2641 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, // Skip to: 2651
/* 2647 */    MCD::OPC_Decode, 220, 3, 50, // Opcode: FMOVS_FCC, DecodeIdx: 50
/* 2651 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2653 */    MCD::OPC_Decode, 183, 6, 51, // Opcode: V9FMOVS_FCC, DecodeIdx: 51
/* 2657 */    MCD::OPC_FilterValueOrFail, 1, 
/* 2659 */    MCD::OPC_ExtractField, 10, 3,  // Inst{12-10} ...
/* 2662 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 2676
/* 2666 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2668 */    MCD::OPC_CheckFieldOrFail, 18, 1, 0, 
/* 2672 */    MCD::OPC_Decode, 221, 3, 50, // Opcode: FMOVS_ICC, DecodeIdx: 50
/* 2676 */    MCD::OPC_FilterValueOrFail, 4, 
/* 2678 */    MCD::OPC_CheckFieldOrFail, 18, 1, 0, 
/* 2682 */    MCD::OPC_Decode, 222, 3, 50, // Opcode: FMOVS_XCC, DecodeIdx: 50
/* 2686 */    MCD::OPC_FilterValue, 2, 66, 0, // Skip to: 2756
/* 2690 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2693 */    MCD::OPC_FilterValue, 0, 30, 0, // Skip to: 2727
/* 2697 */    MCD::OPC_ExtractField, 10, 1,  // Inst{10} ...
/* 2700 */    MCD::OPC_FilterValueOrFail, 0, 
/* 2702 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 2705 */    MCD::OPC_FilterValueOrFail, 0, 
/* 2707 */    MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 2721
/* 2711 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, // Skip to: 2721
/* 2717 */    MCD::OPC_Decode, 209, 3, 52, // Opcode: FMOVD_FCC, DecodeIdx: 52
/* 2721 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2723 */    MCD::OPC_Decode, 181, 6, 53, // Opcode: V9FMOVD_FCC, DecodeIdx: 53
/* 2727 */    MCD::OPC_FilterValueOrFail, 1, 
/* 2729 */    MCD::OPC_ExtractField, 10, 3,  // Inst{12-10} ...
/* 2732 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 2746
/* 2736 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2738 */    MCD::OPC_CheckFieldOrFail, 18, 1, 0, 
/* 2742 */    MCD::OPC_Decode, 210, 3, 52, // Opcode: FMOVD_ICC, DecodeIdx: 52
/* 2746 */    MCD::OPC_FilterValueOrFail, 4, 
/* 2748 */    MCD::OPC_CheckFieldOrFail, 18, 1, 0, 
/* 2752 */    MCD::OPC_Decode, 211, 3, 52, // Opcode: FMOVD_XCC, DecodeIdx: 52
/* 2756 */    MCD::OPC_FilterValue, 3, 66, 0, // Skip to: 2826
/* 2760 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2763 */    MCD::OPC_FilterValue, 0, 30, 0, // Skip to: 2797
/* 2767 */    MCD::OPC_ExtractField, 10, 1,  // Inst{10} ...
/* 2770 */    MCD::OPC_FilterValueOrFail, 0, 
/* 2772 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 2775 */    MCD::OPC_FilterValueOrFail, 0, 
/* 2777 */    MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 2791
/* 2781 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, // Skip to: 2791
/* 2787 */    MCD::OPC_Decode, 213, 3, 54, // Opcode: FMOVQ_FCC, DecodeIdx: 54
/* 2791 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2793 */    MCD::OPC_Decode, 182, 6, 55, // Opcode: V9FMOVQ_FCC, DecodeIdx: 55
/* 2797 */    MCD::OPC_FilterValueOrFail, 1, 
/* 2799 */    MCD::OPC_ExtractField, 10, 3,  // Inst{12-10} ...
/* 2802 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 2816
/* 2806 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2808 */    MCD::OPC_CheckFieldOrFail, 18, 1, 0, 
/* 2812 */    MCD::OPC_Decode, 214, 3, 54, // Opcode: FMOVQ_ICC, DecodeIdx: 54
/* 2816 */    MCD::OPC_FilterValueOrFail, 4, 
/* 2818 */    MCD::OPC_CheckFieldOrFail, 18, 1, 0, 
/* 2822 */    MCD::OPC_Decode, 215, 3, 54, // Opcode: FMOVQ_XCC, DecodeIdx: 54
/* 2826 */    MCD::OPC_FilterValue, 5, 8, 0, // Skip to: 2838
/* 2830 */    MCD::OPC_CheckFieldOrFail, 13, 1, 0, 
/* 2834 */    MCD::OPC_Decode, 218, 3, 56, // Opcode: FMOVRS, DecodeIdx: 56
/* 2838 */    MCD::OPC_FilterValue, 6, 8, 0, // Skip to: 2850
/* 2842 */    MCD::OPC_CheckFieldOrFail, 13, 1, 0, 
/* 2846 */    MCD::OPC_Decode, 216, 3, 57, // Opcode: FMOVRD, DecodeIdx: 57
/* 2850 */    MCD::OPC_FilterValue, 7, 8, 0, // Skip to: 2862
/* 2854 */    MCD::OPC_CheckFieldOrFail, 13, 1, 0, 
/* 2858 */    MCD::OPC_Decode, 217, 3, 58, // Opcode: FMOVRQ, DecodeIdx: 58
/* 2862 */    MCD::OPC_FilterValue, 17, 8, 0, // Skip to: 2874
/* 2866 */    MCD::OPC_CheckFieldOrFail, 10, 4, 2, 
/* 2870 */    MCD::OPC_Decode, 180, 6, 59, // Opcode: V9FCMPS, DecodeIdx: 59
/* 2874 */    MCD::OPC_FilterValue, 18, 8, 0, // Skip to: 2886
/* 2878 */    MCD::OPC_CheckFieldOrFail, 10, 4, 2, 
/* 2882 */    MCD::OPC_Decode, 175, 6, 60, // Opcode: V9FCMPD, DecodeIdx: 60
/* 2886 */    MCD::OPC_FilterValue, 19, 8, 0, // Skip to: 2898
/* 2890 */    MCD::OPC_CheckFieldOrFail, 10, 4, 2, 
/* 2894 */    MCD::OPC_Decode, 179, 6, 61, // Opcode: V9FCMPQ, DecodeIdx: 61
/* 2898 */    MCD::OPC_FilterValue, 21, 8, 0, // Skip to: 2910
/* 2902 */    MCD::OPC_CheckFieldOrFail, 10, 4, 2, 
/* 2906 */    MCD::OPC_Decode, 178, 6, 59, // Opcode: V9FCMPES, DecodeIdx: 59
/* 2910 */    MCD::OPC_FilterValue, 22, 8, 0, // Skip to: 2922
/* 2914 */    MCD::OPC_CheckFieldOrFail, 10, 4, 2, 
/* 2918 */    MCD::OPC_Decode, 176, 6, 60, // Opcode: V9FCMPED, DecodeIdx: 60
/* 2922 */    MCD::OPC_FilterValueOrFail, 23, 
/* 2924 */    MCD::OPC_CheckFieldOrFail, 10, 4, 2, 
/* 2928 */    MCD::OPC_Decode, 177, 6, 61, // Opcode: V9FCMPEQ, DecodeIdx: 61
/* 2932 */    MCD::OPC_FilterValue, 54, 246, 4, // Skip to: 4206
/* 2936 */    MCD::OPC_ExtractField, 5, 9,  // Inst{13-5} ...
/* 2939 */    MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 2949
/* 2943 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 2945 */    MCD::OPC_Decode, 147, 3, 13, // Opcode: EDGE8, DecodeIdx: 13
/* 2949 */    MCD::OPC_FilterValue, 1, 6, 0, // Skip to: 2959
/* 2953 */    MCD::OPC_CheckPredicateOrFail, 6, 
/* 2955 */    MCD::OPC_Decode, 150, 3, 13, // Opcode: EDGE8N, DecodeIdx: 13
/* 2959 */    MCD::OPC_FilterValue, 2, 6, 0, // Skip to: 2969
/* 2963 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 2965 */    MCD::OPC_Decode, 148, 3, 13, // Opcode: EDGE8L, DecodeIdx: 13
/* 2969 */    MCD::OPC_FilterValue, 3, 6, 0, // Skip to: 2979
/* 2973 */    MCD::OPC_CheckPredicateOrFail, 6, 
/* 2975 */    MCD::OPC_Decode, 149, 3, 13, // Opcode: EDGE8LN, DecodeIdx: 13
/* 2979 */    MCD::OPC_FilterValue, 4, 6, 0, // Skip to: 2989
/* 2983 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 2985 */    MCD::OPC_Decode, 139, 3, 13, // Opcode: EDGE16, DecodeIdx: 13
/* 2989 */    MCD::OPC_FilterValue, 5, 6, 0, // Skip to: 2999
/* 2993 */    MCD::OPC_CheckPredicateOrFail, 6, 
/* 2995 */    MCD::OPC_Decode, 142, 3, 13, // Opcode: EDGE16N, DecodeIdx: 13
/* 2999 */    MCD::OPC_FilterValue, 6, 6, 0, // Skip to: 3009
/* 3003 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3005 */    MCD::OPC_Decode, 140, 3, 13, // Opcode: EDGE16L, DecodeIdx: 13
/* 3009 */    MCD::OPC_FilterValue, 7, 6, 0, // Skip to: 3019
/* 3013 */    MCD::OPC_CheckPredicateOrFail, 6, 
/* 3015 */    MCD::OPC_Decode, 141, 3, 13, // Opcode: EDGE16LN, DecodeIdx: 13
/* 3019 */    MCD::OPC_FilterValue, 8, 6, 0, // Skip to: 3029
/* 3023 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3025 */    MCD::OPC_Decode, 143, 3, 13, // Opcode: EDGE32, DecodeIdx: 13
/* 3029 */    MCD::OPC_FilterValue, 9, 6, 0, // Skip to: 3039
/* 3033 */    MCD::OPC_CheckPredicateOrFail, 6, 
/* 3035 */    MCD::OPC_Decode, 146, 3, 13, // Opcode: EDGE32N, DecodeIdx: 13
/* 3039 */    MCD::OPC_FilterValue, 10, 6, 0, // Skip to: 3049
/* 3043 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3045 */    MCD::OPC_Decode, 144, 3, 13, // Opcode: EDGE32L, DecodeIdx: 13
/* 3049 */    MCD::OPC_FilterValue, 11, 6, 0, // Skip to: 3059
/* 3053 */    MCD::OPC_CheckPredicateOrFail, 6, 
/* 3055 */    MCD::OPC_Decode, 145, 3, 13, // Opcode: EDGE32LN, DecodeIdx: 13
/* 3059 */    MCD::OPC_FilterValue, 16, 6, 0, // Skip to: 3069
/* 3063 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3065 */    MCD::OPC_Decode, 223, 2, 13, // Opcode: ARRAY8, DecodeIdx: 13
/* 3069 */    MCD::OPC_FilterValue, 17, 6, 0, // Skip to: 3079
/* 3073 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3075 */    MCD::OPC_Decode, 206, 2, 13, // Opcode: ADDXC, DecodeIdx: 13
/* 3079 */    MCD::OPC_FilterValue, 18, 6, 0, // Skip to: 3089
/* 3083 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3085 */    MCD::OPC_Decode, 221, 2, 13, // Opcode: ARRAY16, DecodeIdx: 13
/* 3089 */    MCD::OPC_FilterValue, 19, 6, 0, // Skip to: 3099
/* 3093 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3095 */    MCD::OPC_Decode, 207, 2, 13, // Opcode: ADDXCCC, DecodeIdx: 13
/* 3099 */    MCD::OPC_FilterValue, 20, 6, 0, // Skip to: 3109
/* 3103 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3105 */    MCD::OPC_Decode, 222, 2, 13, // Opcode: ARRAY32, DecodeIdx: 13
/* 3109 */    MCD::OPC_FilterValue, 22, 6, 0, // Skip to: 3119
/* 3113 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3115 */    MCD::OPC_Decode, 171, 6, 13, // Opcode: UMULXHI, DecodeIdx: 13
/* 3119 */    MCD::OPC_FilterValue, 23, 10, 0, // Skip to: 3133
/* 3123 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3125 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 3129 */    MCD::OPC_Decode, 251, 4, 62, // Opcode: LZCNT, DecodeIdx: 62
/* 3133 */    MCD::OPC_FilterValue, 24, 6, 0, // Skip to: 3143
/* 3137 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3139 */    MCD::OPC_Decode, 210, 2, 13, // Opcode: ALIGNADDR, DecodeIdx: 13
/* 3143 */    MCD::OPC_FilterValue, 25, 6, 0, // Skip to: 3153
/* 3147 */    MCD::OPC_CheckPredicateOrFail, 6, 
/* 3149 */    MCD::OPC_Decode, 229, 2, 13, // Opcode: BMASK, DecodeIdx: 13
/* 3153 */    MCD::OPC_FilterValue, 26, 6, 0, // Skip to: 3163
/* 3157 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3159 */    MCD::OPC_Decode, 211, 2, 13, // Opcode: ALIGNADDRL, DecodeIdx: 13
/* 3163 */    MCD::OPC_FilterValue, 27, 14, 0, // Skip to: 3181
/* 3167 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3169 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 3173 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 3177 */    MCD::OPC_Decode, 131, 3, 63, // Opcode: CMASK8, DecodeIdx: 63
/* 3181 */    MCD::OPC_FilterValue, 29, 14, 0, // Skip to: 3199
/* 3185 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3187 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 3191 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 3195 */    MCD::OPC_Decode, 129, 3, 63, // Opcode: CMASK16, DecodeIdx: 63
/* 3199 */    MCD::OPC_FilterValue, 31, 14, 0, // Skip to: 3217
/* 3203 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3205 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 3209 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 3213 */    MCD::OPC_Decode, 130, 3, 63, // Opcode: CMASK32, DecodeIdx: 63
/* 3217 */    MCD::OPC_FilterValue, 32, 6, 0, // Skip to: 3227
/* 3221 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3223 */    MCD::OPC_Decode, 175, 3, 64, // Opcode: FCMPLE16, DecodeIdx: 64
/* 3227 */    MCD::OPC_FilterValue, 33, 6, 0, // Skip to: 3237
/* 3231 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3233 */    MCD::OPC_Decode, 158, 4, 40, // Opcode: FSLL16, DecodeIdx: 40
/* 3237 */    MCD::OPC_FilterValue, 34, 6, 0, // Skip to: 3247
/* 3241 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3243 */    MCD::OPC_Decode, 177, 3, 64, // Opcode: FCMPNE16, DecodeIdx: 64
/* 3247 */    MCD::OPC_FilterValue, 35, 6, 0, // Skip to: 3257
/* 3251 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3253 */    MCD::OPC_Decode, 170, 4, 40, // Opcode: FSRL16, DecodeIdx: 40
/* 3257 */    MCD::OPC_FilterValue, 36, 6, 0, // Skip to: 3267
/* 3261 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3263 */    MCD::OPC_Decode, 176, 3, 64, // Opcode: FCMPLE32, DecodeIdx: 64
/* 3267 */    MCD::OPC_FilterValue, 37, 6, 0, // Skip to: 3277
/* 3271 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3273 */    MCD::OPC_Decode, 159, 4, 40, // Opcode: FSLL32, DecodeIdx: 40
/* 3277 */    MCD::OPC_FilterValue, 38, 6, 0, // Skip to: 3287
/* 3281 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3283 */    MCD::OPC_Decode, 178, 3, 64, // Opcode: FCMPNE32, DecodeIdx: 64
/* 3287 */    MCD::OPC_FilterValue, 39, 6, 0, // Skip to: 3297
/* 3291 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3293 */    MCD::OPC_Decode, 171, 4, 40, // Opcode: FSRL32, DecodeIdx: 40
/* 3297 */    MCD::OPC_FilterValue, 40, 6, 0, // Skip to: 3307
/* 3301 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3303 */    MCD::OPC_Decode, 173, 3, 64, // Opcode: FCMPGT16, DecodeIdx: 64
/* 3307 */    MCD::OPC_FilterValue, 41, 6, 0, // Skip to: 3317
/* 3311 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3313 */    MCD::OPC_Decode, 156, 4, 40, // Opcode: FSLAS16, DecodeIdx: 40
/* 3317 */    MCD::OPC_FilterValue, 42, 6, 0, // Skip to: 3327
/* 3321 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3323 */    MCD::OPC_Decode, 171, 3, 64, // Opcode: FCMPEQ16, DecodeIdx: 64
/* 3327 */    MCD::OPC_FilterValue, 43, 6, 0, // Skip to: 3337
/* 3331 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3333 */    MCD::OPC_Decode, 164, 4, 40, // Opcode: FSRA16, DecodeIdx: 40
/* 3337 */    MCD::OPC_FilterValue, 44, 6, 0, // Skip to: 3347
/* 3341 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3343 */    MCD::OPC_Decode, 174, 3, 64, // Opcode: FCMPGT32, DecodeIdx: 64
/* 3347 */    MCD::OPC_FilterValue, 45, 6, 0, // Skip to: 3357
/* 3351 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3353 */    MCD::OPC_Decode, 157, 4, 40, // Opcode: FSLAS32, DecodeIdx: 40
/* 3357 */    MCD::OPC_FilterValue, 46, 6, 0, // Skip to: 3367
/* 3361 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3363 */    MCD::OPC_Decode, 172, 3, 64, // Opcode: FCMPEQ32, DecodeIdx: 64
/* 3367 */    MCD::OPC_FilterValue, 47, 6, 0, // Skip to: 3377
/* 3371 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3373 */    MCD::OPC_Decode, 165, 4, 40, // Opcode: FSRA32, DecodeIdx: 40
/* 3377 */    MCD::OPC_FilterValue, 49, 6, 0, // Skip to: 3387
/* 3381 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3383 */    MCD::OPC_Decode, 227, 3, 65, // Opcode: FMUL8X16, DecodeIdx: 65
/* 3387 */    MCD::OPC_FilterValue, 51, 6, 0, // Skip to: 3397
/* 3391 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3393 */    MCD::OPC_Decode, 229, 3, 42, // Opcode: FMUL8X16AU, DecodeIdx: 42
/* 3397 */    MCD::OPC_FilterValue, 53, 6, 0, // Skip to: 3407
/* 3401 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3403 */    MCD::OPC_Decode, 228, 3, 42, // Opcode: FMUL8X16AL, DecodeIdx: 42
/* 3407 */    MCD::OPC_FilterValue, 54, 6, 0, // Skip to: 3417
/* 3411 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3413 */    MCD::OPC_Decode, 225, 3, 40, // Opcode: FMUL8SUX16, DecodeIdx: 40
/* 3417 */    MCD::OPC_FilterValue, 55, 6, 0, // Skip to: 3427
/* 3421 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3423 */    MCD::OPC_Decode, 226, 3, 40, // Opcode: FMUL8ULX16, DecodeIdx: 40
/* 3427 */    MCD::OPC_FilterValue, 56, 6, 0, // Skip to: 3437
/* 3431 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3433 */    MCD::OPC_Decode, 231, 3, 42, // Opcode: FMULD8SUX16, DecodeIdx: 42
/* 3437 */    MCD::OPC_FilterValue, 57, 6, 0, // Skip to: 3447
/* 3441 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3443 */    MCD::OPC_Decode, 232, 3, 42, // Opcode: FMULD8ULX16, DecodeIdx: 42
/* 3447 */    MCD::OPC_FilterValue, 58, 6, 0, // Skip to: 3457
/* 3451 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3453 */    MCD::OPC_Decode, 138, 4, 40, // Opcode: FPACK32, DecodeIdx: 40
/* 3457 */    MCD::OPC_FilterValue, 59, 10, 0, // Skip to: 3471
/* 3461 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3463 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 3467 */    MCD::OPC_Decode, 137, 4, 37, // Opcode: FPACK16, DecodeIdx: 37
/* 3471 */    MCD::OPC_FilterValue, 61, 10, 0, // Skip to: 3485
/* 3475 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3477 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 3481 */    MCD::OPC_Decode, 139, 4, 46, // Opcode: FPACKFIX, DecodeIdx: 46
/* 3485 */    MCD::OPC_FilterValue, 62, 6, 0, // Skip to: 3495
/* 3489 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3491 */    MCD::OPC_Decode, 153, 5, 40, // Opcode: PDIST, DecodeIdx: 40
/* 3495 */    MCD::OPC_FilterValue, 63, 6, 0, // Skip to: 3505
/* 3499 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3501 */    MCD::OPC_Decode, 154, 5, 64, // Opcode: PDISTN, DecodeIdx: 64
/* 3505 */    MCD::OPC_FilterValue, 64, 6, 0, // Skip to: 3515
/* 3509 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3511 */    MCD::OPC_Decode, 207, 3, 40, // Opcode: FMEAN16, DecodeIdx: 40
/* 3515 */    MCD::OPC_FilterValue, 66, 6, 0, // Skip to: 3525
/* 3519 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3521 */    MCD::OPC_Decode, 144, 4, 40, // Opcode: FPADD64, DecodeIdx: 40
/* 3525 */    MCD::OPC_FilterValue, 68, 6, 0, // Skip to: 3535
/* 3529 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3531 */    MCD::OPC_Decode, 168, 3, 40, // Opcode: FCHKSM16, DecodeIdx: 40
/* 3535 */    MCD::OPC_FilterValue, 72, 6, 0, // Skip to: 3545
/* 3539 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3541 */    MCD::OPC_Decode, 157, 3, 40, // Opcode: FALIGNADATA, DecodeIdx: 40
/* 3545 */    MCD::OPC_FilterValue, 75, 6, 0, // Skip to: 3555
/* 3549 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3551 */    MCD::OPC_Decode, 147, 4, 42, // Opcode: FPMERGE, DecodeIdx: 42
/* 3555 */    MCD::OPC_FilterValue, 76, 6, 0, // Skip to: 3565
/* 3559 */    MCD::OPC_CheckPredicateOrFail, 6, 
/* 3561 */    MCD::OPC_Decode, 246, 2, 40, // Opcode: BSHUFFLE, DecodeIdx: 40
/* 3565 */    MCD::OPC_FilterValue, 77, 10, 0, // Skip to: 3579
/* 3569 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3571 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 3575 */    MCD::OPC_Decode, 191, 3, 44, // Opcode: FEXPAND, DecodeIdx: 44
/* 3579 */    MCD::OPC_FilterValue, 80, 6, 0, // Skip to: 3589
/* 3583 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3585 */    MCD::OPC_Decode, 140, 4, 40, // Opcode: FPADD16, DecodeIdx: 40
/* 3589 */    MCD::OPC_FilterValue, 81, 6, 0, // Skip to: 3599
/* 3593 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3595 */    MCD::OPC_Decode, 141, 4, 39, // Opcode: FPADD16S, DecodeIdx: 39
/* 3599 */    MCD::OPC_FilterValue, 82, 6, 0, // Skip to: 3609
/* 3603 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3605 */    MCD::OPC_Decode, 142, 4, 40, // Opcode: FPADD32, DecodeIdx: 40
/* 3609 */    MCD::OPC_FilterValue, 83, 6, 0, // Skip to: 3619
/* 3613 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3615 */    MCD::OPC_Decode, 143, 4, 39, // Opcode: FPADD32S, DecodeIdx: 39
/* 3619 */    MCD::OPC_FilterValue, 84, 6, 0, // Skip to: 3629
/* 3623 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3625 */    MCD::OPC_Decode, 148, 4, 40, // Opcode: FPSUB16, DecodeIdx: 40
/* 3629 */    MCD::OPC_FilterValue, 85, 6, 0, // Skip to: 3639
/* 3633 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3635 */    MCD::OPC_Decode, 149, 4, 39, // Opcode: FPSUB16S, DecodeIdx: 39
/* 3639 */    MCD::OPC_FilterValue, 86, 6, 0, // Skip to: 3649
/* 3643 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3645 */    MCD::OPC_Decode, 150, 4, 40, // Opcode: FPSUB32, DecodeIdx: 40
/* 3649 */    MCD::OPC_FilterValue, 87, 6, 0, // Skip to: 3659
/* 3653 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3655 */    MCD::OPC_Decode, 151, 4, 39, // Opcode: FPSUB32S, DecodeIdx: 39
/* 3659 */    MCD::OPC_FilterValue, 96, 14, 0, // Skip to: 3677
/* 3663 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3665 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 3669 */    MCD::OPC_CheckFieldOrFail, 0, 5, 0, 
/* 3673 */    MCD::OPC_Decode, 186, 4, 66, // Opcode: FZERO, DecodeIdx: 66
/* 3677 */    MCD::OPC_FilterValue, 97, 14, 0, // Skip to: 3695
/* 3681 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3683 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 3687 */    MCD::OPC_CheckFieldOrFail, 0, 5, 0, 
/* 3691 */    MCD::OPC_Decode, 187, 4, 67, // Opcode: FZEROS, DecodeIdx: 67
/* 3695 */    MCD::OPC_FilterValue, 98, 6, 0, // Skip to: 3705
/* 3699 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3701 */    MCD::OPC_Decode, 250, 3, 40, // Opcode: FNOR, DecodeIdx: 40
/* 3705 */    MCD::OPC_FilterValue, 99, 6, 0, // Skip to: 3715
/* 3709 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3711 */    MCD::OPC_Decode, 251, 3, 39, // Opcode: FNORS, DecodeIdx: 39
/* 3715 */    MCD::OPC_FilterValue, 100, 6, 0, // Skip to: 3725
/* 3719 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3721 */    MCD::OPC_Decode, 161, 3, 40, // Opcode: FANDNOT2, DecodeIdx: 40
/* 3725 */    MCD::OPC_FilterValue, 101, 6, 0, // Skip to: 3735
/* 3729 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3731 */    MCD::OPC_Decode, 162, 3, 39, // Opcode: FANDNOT2S, DecodeIdx: 39
/* 3735 */    MCD::OPC_FilterValue, 102, 10, 0, // Skip to: 3749
/* 3739 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3741 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 3745 */    MCD::OPC_Decode, 254, 3, 37, // Opcode: FNOT2, DecodeIdx: 37
/* 3749 */    MCD::OPC_FilterValue, 103, 10, 0, // Skip to: 3763
/* 3753 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3755 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 3759 */    MCD::OPC_Decode, 255, 3, 36, // Opcode: FNOT2S, DecodeIdx: 36
/* 3763 */    MCD::OPC_FilterValue, 104, 6, 0, // Skip to: 3773
/* 3767 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3769 */    MCD::OPC_Decode, 159, 3, 40, // Opcode: FANDNOT1, DecodeIdx: 40
/* 3773 */    MCD::OPC_FilterValue, 105, 6, 0, // Skip to: 3783
/* 3777 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3779 */    MCD::OPC_Decode, 160, 3, 39, // Opcode: FANDNOT1S, DecodeIdx: 39
/* 3783 */    MCD::OPC_FilterValue, 106, 10, 0, // Skip to: 3797
/* 3787 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3789 */    MCD::OPC_CheckFieldOrFail, 0, 5, 0, 
/* 3793 */    MCD::OPC_Decode, 252, 3, 68, // Opcode: FNOT1, DecodeIdx: 68
/* 3797 */    MCD::OPC_FilterValue, 107, 10, 0, // Skip to: 3811
/* 3801 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3803 */    MCD::OPC_CheckFieldOrFail, 0, 5, 0, 
/* 3807 */    MCD::OPC_Decode, 253, 3, 69, // Opcode: FNOT1S, DecodeIdx: 69
/* 3811 */    MCD::OPC_FilterValue, 108, 6, 0, // Skip to: 3821
/* 3815 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3817 */    MCD::OPC_Decode, 181, 4, 40, // Opcode: FXOR, DecodeIdx: 40
/* 3821 */    MCD::OPC_FilterValue, 109, 6, 0, // Skip to: 3831
/* 3825 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3827 */    MCD::OPC_Decode, 182, 4, 39, // Opcode: FXORS, DecodeIdx: 39
/* 3831 */    MCD::OPC_FilterValue, 110, 6, 0, // Skip to: 3841
/* 3835 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3837 */    MCD::OPC_Decode, 237, 3, 40, // Opcode: FNAND, DecodeIdx: 40
/* 3841 */    MCD::OPC_FilterValue, 111, 6, 0, // Skip to: 3851
/* 3845 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3847 */    MCD::OPC_Decode, 238, 3, 39, // Opcode: FNANDS, DecodeIdx: 39
/* 3851 */    MCD::OPC_FilterValue, 112, 6, 0, // Skip to: 3861
/* 3855 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3857 */    MCD::OPC_Decode, 158, 3, 40, // Opcode: FAND, DecodeIdx: 40
/* 3861 */    MCD::OPC_FilterValue, 113, 6, 0, // Skip to: 3871
/* 3865 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3867 */    MCD::OPC_Decode, 163, 3, 39, // Opcode: FANDS, DecodeIdx: 39
/* 3871 */    MCD::OPC_FilterValue, 114, 6, 0, // Skip to: 3881
/* 3875 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3877 */    MCD::OPC_Decode, 179, 4, 40, // Opcode: FXNOR, DecodeIdx: 40
/* 3881 */    MCD::OPC_FilterValue, 115, 6, 0, // Skip to: 3891
/* 3885 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3887 */    MCD::OPC_Decode, 180, 4, 39, // Opcode: FXNORS, DecodeIdx: 39
/* 3891 */    MCD::OPC_FilterValue, 116, 10, 0, // Skip to: 3905
/* 3895 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3897 */    MCD::OPC_CheckFieldOrFail, 0, 5, 0, 
/* 3901 */    MCD::OPC_Decode, 166, 4, 68, // Opcode: FSRC1, DecodeIdx: 68
/* 3905 */    MCD::OPC_FilterValue, 117, 10, 0, // Skip to: 3919
/* 3909 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3911 */    MCD::OPC_CheckFieldOrFail, 0, 5, 0, 
/* 3915 */    MCD::OPC_Decode, 167, 4, 69, // Opcode: FSRC1S, DecodeIdx: 69
/* 3919 */    MCD::OPC_FilterValue, 118, 6, 0, // Skip to: 3929
/* 3923 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3925 */    MCD::OPC_Decode, 134, 4, 40, // Opcode: FORNOT2, DecodeIdx: 40
/* 3929 */    MCD::OPC_FilterValue, 119, 6, 0, // Skip to: 3939
/* 3933 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3935 */    MCD::OPC_Decode, 135, 4, 39, // Opcode: FORNOT2S, DecodeIdx: 39
/* 3939 */    MCD::OPC_FilterValue, 120, 10, 0, // Skip to: 3953
/* 3943 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3945 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 3949 */    MCD::OPC_Decode, 168, 4, 37, // Opcode: FSRC2, DecodeIdx: 37
/* 3953 */    MCD::OPC_FilterValue, 121, 10, 0, // Skip to: 3967
/* 3957 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3959 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 3963 */    MCD::OPC_Decode, 169, 4, 36, // Opcode: FSRC2S, DecodeIdx: 36
/* 3967 */    MCD::OPC_FilterValue, 122, 6, 0, // Skip to: 3977
/* 3971 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3973 */    MCD::OPC_Decode, 132, 4, 40, // Opcode: FORNOT1, DecodeIdx: 40
/* 3977 */    MCD::OPC_FilterValue, 123, 6, 0, // Skip to: 3987
/* 3981 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3983 */    MCD::OPC_Decode, 133, 4, 39, // Opcode: FORNOT1S, DecodeIdx: 39
/* 3987 */    MCD::OPC_FilterValue, 124, 6, 0, // Skip to: 3997
/* 3991 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3993 */    MCD::OPC_Decode, 131, 4, 40, // Opcode: FOR, DecodeIdx: 40
/* 3997 */    MCD::OPC_FilterValue, 125, 6, 0, // Skip to: 4007
/* 4001 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 4003 */    MCD::OPC_Decode, 136, 4, 39, // Opcode: FORS, DecodeIdx: 39
/* 4007 */    MCD::OPC_FilterValue, 126, 14, 0, // Skip to: 4025
/* 4011 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 4013 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 4017 */    MCD::OPC_CheckFieldOrFail, 0, 5, 0, 
/* 4021 */    MCD::OPC_Decode, 129, 4, 66, // Opcode: FONE, DecodeIdx: 66
/* 4025 */    MCD::OPC_FilterValue, 127, 14, 0, // Skip to: 4043
/* 4029 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 4031 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 4035 */    MCD::OPC_CheckFieldOrFail, 0, 5, 0, 
/* 4039 */    MCD::OPC_Decode, 130, 4, 67, // Opcode: FONES, DecodeIdx: 67
/* 4043 */    MCD::OPC_FilterValue, 128, 1, 18, 0, // Skip to: 4066
/* 4048 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 4050 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 4054 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 4058 */    MCD::OPC_CheckFieldOrFail, 0, 5, 0, 
/* 4062 */    MCD::OPC_Decode, 186, 5, 7, // Opcode: SHUTDOWN, DecodeIdx: 7
/* 4066 */    MCD::OPC_FilterValue, 129, 1, 18, 0, // Skip to: 4089
/* 4071 */    MCD::OPC_CheckPredicateOrFail, 6, 
/* 4073 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 4077 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 4081 */    MCD::OPC_CheckFieldOrFail, 3, 2, 0, 
/* 4085 */    MCD::OPC_Decode, 187, 5, 70, // Opcode: SIAM, DecodeIdx: 70
/* 4089 */    MCD::OPC_FilterValue, 144, 2, 10, 0, // Skip to: 4104
/* 4094 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 4096 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 4100 */    MCD::OPC_Decode, 253, 4, 71, // Opcode: MOVDTOX, DecodeIdx: 71
/* 4104 */    MCD::OPC_FilterValue, 145, 2, 10, 0, // Skip to: 4119
/* 4109 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 4111 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 4115 */    MCD::OPC_Decode, 133, 5, 72, // Opcode: MOVSTOUW, DecodeIdx: 72
/* 4119 */    MCD::OPC_FilterValue, 147, 2, 10, 0, // Skip to: 4134
/* 4124 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 4126 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 4130 */    MCD::OPC_Decode, 132, 5, 72, // Opcode: MOVSTOSW, DecodeIdx: 72
/* 4134 */    MCD::OPC_FilterValue, 149, 2, 6, 0, // Skip to: 4145
/* 4139 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 4141 */    MCD::OPC_Decode, 196, 6, 13, // Opcode: XMULX, DecodeIdx: 13
/* 4145 */    MCD::OPC_FilterValue, 150, 2, 6, 0, // Skip to: 4156
/* 4150 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 4152 */    MCD::OPC_Decode, 197, 6, 13, // Opcode: XMULXHI, DecodeIdx: 13
/* 4156 */    MCD::OPC_FilterValue, 152, 2, 10, 0, // Skip to: 4171
/* 4161 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 4163 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 4167 */    MCD::OPC_Decode, 137, 5, 73, // Opcode: MOVXTOD, DecodeIdx: 73
/* 4171 */    MCD::OPC_FilterValue, 153, 2, 10, 0, // Skip to: 4186
/* 4176 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 4178 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 4182 */    MCD::OPC_Decode, 134, 5, 74, // Opcode: MOVWTOS, DecodeIdx: 74
/* 4186 */    MCD::OPC_FilterValue, 209, 2, 6, 0, // Skip to: 4197
/* 4191 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 4193 */    MCD::OPC_Decode, 200, 3, 59, // Opcode: FLCMPS, DecodeIdx: 59
/* 4197 */    MCD::OPC_FilterValueOrFail, 210, 2, 
/* 4200 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 4202 */    MCD::OPC_Decode, 199, 3, 60, // Opcode: FLCMPD, DecodeIdx: 60
/* 4206 */    MCD::OPC_FilterValue, 55, 101, 0, // Skip to: 4311
/* 4210 */    MCD::OPC_ExtractField, 5, 4,  // Inst{8-5} ...
/* 4213 */    MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 4223
/* 4217 */    MCD::OPC_CheckPredicateOrFail, 1, 
/* 4219 */    MCD::OPC_Decode, 145, 4, 75, // Opcode: FPMADDX, DecodeIdx: 75
/* 4223 */    MCD::OPC_FilterValue, 1, 6, 0, // Skip to: 4233
/* 4227 */    MCD::OPC_CheckPredicateOrFail, 7, 
/* 4229 */    MCD::OPC_Decode, 206, 3, 76, // Opcode: FMADDS, DecodeIdx: 76
/* 4233 */    MCD::OPC_FilterValue, 2, 6, 0, // Skip to: 4243
/* 4237 */    MCD::OPC_CheckPredicateOrFail, 7, 
/* 4239 */    MCD::OPC_Decode, 205, 3, 75, // Opcode: FMADDD, DecodeIdx: 75
/* 4243 */    MCD::OPC_FilterValue, 4, 6, 0, // Skip to: 4253
/* 4247 */    MCD::OPC_CheckPredicateOrFail, 1, 
/* 4249 */    MCD::OPC_Decode, 146, 4, 75, // Opcode: FPMADDXHI, DecodeIdx: 75
/* 4253 */    MCD::OPC_FilterValue, 5, 6, 0, // Skip to: 4263
/* 4257 */    MCD::OPC_CheckPredicateOrFail, 7, 
/* 4259 */    MCD::OPC_Decode, 224, 3, 76, // Opcode: FMSUBS, DecodeIdx: 76
/* 4263 */    MCD::OPC_FilterValue, 6, 6, 0, // Skip to: 4273
/* 4267 */    MCD::OPC_CheckPredicateOrFail, 7, 
/* 4269 */    MCD::OPC_Decode, 223, 3, 75, // Opcode: FMSUBD, DecodeIdx: 75
/* 4273 */    MCD::OPC_FilterValue, 9, 6, 0, // Skip to: 4283
/* 4277 */    MCD::OPC_CheckPredicateOrFail, 7, 
/* 4279 */    MCD::OPC_Decode, 247, 3, 76, // Opcode: FNMSUBS, DecodeIdx: 76
/* 4283 */    MCD::OPC_FilterValue, 10, 6, 0, // Skip to: 4293
/* 4287 */    MCD::OPC_CheckPredicateOrFail, 7, 
/* 4289 */    MCD::OPC_Decode, 246, 3, 75, // Opcode: FNMSUBD, DecodeIdx: 75
/* 4293 */    MCD::OPC_FilterValue, 13, 6, 0, // Skip to: 4303
/* 4297 */    MCD::OPC_CheckPredicateOrFail, 7, 
/* 4299 */    MCD::OPC_Decode, 245, 3, 76, // Opcode: FNMADDS, DecodeIdx: 76
/* 4303 */    MCD::OPC_FilterValueOrFail, 14, 
/* 4305 */    MCD::OPC_CheckPredicateOrFail, 7, 
/* 4307 */    MCD::OPC_Decode, 244, 3, 75, // Opcode: FNMADDD, DecodeIdx: 75
/* 4311 */    MCD::OPC_FilterValue, 56, 21, 0, // Skip to: 4336
/* 4315 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4318 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4330
/* 4322 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4326 */    MCD::OPC_Decode, 192, 4, 77, // Opcode: JMPLrr, DecodeIdx: 77
/* 4330 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4332 */    MCD::OPC_Decode, 191, 4, 78, // Opcode: JMPLri, DecodeIdx: 78
/* 4336 */    MCD::OPC_FilterValue, 57, 29, 0, // Skip to: 4369
/* 4340 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4343 */    MCD::OPC_FilterValue, 0, 12, 0, // Skip to: 4359
/* 4347 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 4351 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4355 */    MCD::OPC_Decode, 175, 5, 79, // Opcode: RETTrr, DecodeIdx: 79
/* 4359 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4361 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 4365 */    MCD::OPC_Decode, 174, 5, 80, // Opcode: RETTri, DecodeIdx: 80
/* 4369 */    MCD::OPC_FilterValue, 58, 82, 0, // Skip to: 4455
/* 4373 */    MCD::OPC_ExtractField, 8, 6,  // Inst{13-8} ...
/* 4376 */    MCD::OPC_FilterValue, 16, 12, 0, // Skip to: 4392
/* 4380 */    MCD::OPC_CheckFieldOrFail, 29, 1, 0, 
/* 4384 */    MCD::OPC_CheckFieldOrFail, 5, 3, 0, 
/* 4388 */    MCD::OPC_Decode, 160, 6, 81, // Opcode: TXCCrr, DecodeIdx: 81
/* 4392 */    MCD::OPC_FilterValue, 32, 49, 0, // Skip to: 4445
/* 4396 */    MCD::OPC_ExtractField, 0, 8,  // Inst{7-0} ...
/* 4399 */    MCD::OPC_FilterValue, 1, 12, 0, // Skip to: 4415
/* 4403 */    MCD::OPC_CheckFieldOrFail, 25, 5, 8, 
/* 4407 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 4411 */    MCD::OPC_Decode, 138, 6, 7, // Opcode: TA1, DecodeIdx: 7
/* 4415 */    MCD::OPC_FilterValue, 3, 12, 0, // Skip to: 4431
/* 4419 */    MCD::OPC_CheckFieldOrFail, 25, 5, 8, 
/* 4423 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 4427 */    MCD::OPC_Decode, 139, 6, 7, // Opcode: TA3, DecodeIdx: 7
/* 4431 */    MCD::OPC_FilterValueOrFail, 5, 
/* 4433 */    MCD::OPC_CheckFieldOrFail, 25, 5, 8, 
/* 4437 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 4441 */    MCD::OPC_Decode, 140, 6, 7, // Opcode: TA5, DecodeIdx: 7
/* 4445 */    MCD::OPC_FilterValueOrFail, 48, 
/* 4447 */    MCD::OPC_CheckFieldOrFail, 29, 1, 0, 
/* 4451 */    MCD::OPC_Decode, 159, 6, 82, // Opcode: TXCCri, DecodeIdx: 82
/* 4455 */    MCD::OPC_FilterValue, 59, 47, 0, // Skip to: 4506
/* 4459 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4462 */    MCD::OPC_FilterValue, 0, 30, 0, // Skip to: 4496
/* 4466 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 4469 */    MCD::OPC_FilterValueOrFail, 0, 
/* 4471 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 4474 */    MCD::OPC_FilterValueOrFail, 0, 
/* 4476 */    MCD::OPC_CheckField, 14, 5, 0, 10, 0, // Skip to: 4492
/* 4482 */    MCD::OPC_CheckField, 0, 5, 0, 4, 0, // Skip to: 4492
/* 4488 */    MCD::OPC_Decode, 201, 3, 7, // Opcode: FLUSH, DecodeIdx: 7
/* 4492 */    MCD::OPC_Decode, 204, 3, 79, // Opcode: FLUSHrr, DecodeIdx: 79
/* 4496 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4498 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 4502 */    MCD::OPC_Decode, 203, 3, 80, // Opcode: FLUSHri, DecodeIdx: 80
/* 4506 */    MCD::OPC_FilterValue, 60, 21, 0, // Skip to: 4531
/* 4510 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4513 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4525
/* 4517 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4521 */    MCD::OPC_Decode, 178, 5, 11, // Opcode: SAVErr, DecodeIdx: 11
/* 4525 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4527 */    MCD::OPC_Decode, 177, 5, 12, // Opcode: SAVEri, DecodeIdx: 12
/* 4531 */    MCD::OPC_FilterValue, 61, 21, 0, // Skip to: 4556
/* 4535 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4538 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4550
/* 4542 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4546 */    MCD::OPC_Decode, 170, 5, 11, // Opcode: RESTORErr, DecodeIdx: 11
/* 4550 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4552 */    MCD::OPC_Decode, 169, 5, 12, // Opcode: RESTOREri, DecodeIdx: 12
/* 4556 */    MCD::OPC_FilterValue, 62, 73, 0, // Skip to: 4633
/* 4560 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4563 */    MCD::OPC_FilterValue, 0, 60, 0, // Skip to: 4627
/* 4567 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 4570 */    MCD::OPC_FilterValueOrFail, 0, 
/* 4572 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 4575 */    MCD::OPC_FilterValue, 0, 20, 0, // Skip to: 4599
/* 4579 */    MCD::OPC_CheckPredicate, 0, 40, 0, // Skip to: 4623
/* 4583 */    MCD::OPC_CheckField, 14, 5, 0, 34, 0, // Skip to: 4623
/* 4589 */    MCD::OPC_CheckField, 0, 5, 0, 28, 0, // Skip to: 4623
/* 4595 */    MCD::OPC_Decode, 138, 3, 7, // Opcode: DONE, DecodeIdx: 7
/* 4599 */    MCD::OPC_FilterValue, 1, 20, 0, // Skip to: 4623
/* 4603 */    MCD::OPC_CheckPredicate, 0, 16, 0, // Skip to: 4623
/* 4607 */    MCD::OPC_CheckField, 14, 5, 0, 10, 0, // Skip to: 4623
/* 4613 */    MCD::OPC_CheckField, 0, 5, 0, 4, 0, // Skip to: 4623
/* 4619 */    MCD::OPC_Decode, 173, 5, 7, // Opcode: RETRY, DecodeIdx: 7
/* 4623 */    MCD::OPC_Decode, 168, 6, 11, // Opcode: UMACrr, DecodeIdx: 11
/* 4627 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4629 */    MCD::OPC_Decode, 167, 6, 12, // Opcode: UMACri, DecodeIdx: 12
/* 4633 */    MCD::OPC_FilterValueOrFail, 63, 
/* 4635 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4638 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4650
/* 4642 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4646 */    MCD::OPC_Decode, 194, 5, 11, // Opcode: SMACrr, DecodeIdx: 11
/* 4650 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4652 */    MCD::OPC_Decode, 193, 5, 12, // Opcode: SMACri, DecodeIdx: 12
/* 4656 */    MCD::OPC_FilterValueOrFail, 3, 
/* 4658 */    MCD::OPC_ExtractField, 19, 6,  // Inst{24-19} ...
/* 4661 */    MCD::OPC_FilterValue, 0, 21, 0, // Skip to: 4686
/* 4665 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4668 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4680
/* 4672 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4676 */    MCD::OPC_Decode, 250, 4, 77, // Opcode: LDrr, DecodeIdx: 77
/* 4680 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4682 */    MCD::OPC_Decode, 249, 4, 78, // Opcode: LDri, DecodeIdx: 78
/* 4686 */    MCD::OPC_FilterValue, 1, 21, 0, // Skip to: 4711
/* 4690 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4693 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4705
/* 4697 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4701 */    MCD::OPC_Decode, 238, 4, 77, // Opcode: LDUBrr, DecodeIdx: 77
/* 4705 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4707 */    MCD::OPC_Decode, 237, 4, 78, // Opcode: LDUBri, DecodeIdx: 78
/* 4711 */    MCD::OPC_FilterValue, 2, 21, 0, // Skip to: 4736
/* 4715 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4718 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4730
/* 4722 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4726 */    MCD::OPC_Decode, 242, 4, 77, // Opcode: LDUHrr, DecodeIdx: 77
/* 4730 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4732 */    MCD::OPC_Decode, 241, 4, 78, // Opcode: LDUHri, DecodeIdx: 78
/* 4736 */    MCD::OPC_FilterValue, 3, 21, 0, // Skip to: 4761
/* 4740 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4743 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4755
/* 4747 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4751 */    MCD::OPC_Decode, 208, 4, 83, // Opcode: LDDrr, DecodeIdx: 83
/* 4755 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4757 */    MCD::OPC_Decode, 207, 4, 84, // Opcode: LDDri, DecodeIdx: 84
/* 4761 */    MCD::OPC_FilterValue, 4, 21, 0, // Skip to: 4786
/* 4765 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4768 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4780
/* 4772 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4776 */    MCD::OPC_Decode, 253, 5, 85, // Opcode: STrr, DecodeIdx: 85
/* 4780 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4782 */    MCD::OPC_Decode, 252, 5, 86, // Opcode: STri, DecodeIdx: 86
/* 4786 */    MCD::OPC_FilterValue, 5, 21, 0, // Skip to: 4811
/* 4790 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4793 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4805
/* 4797 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4801 */    MCD::OPC_Decode, 213, 5, 85, // Opcode: STBrr, DecodeIdx: 85
/* 4805 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4807 */    MCD::OPC_Decode, 212, 5, 86, // Opcode: STBri, DecodeIdx: 86
/* 4811 */    MCD::OPC_FilterValue, 6, 21, 0, // Skip to: 4836
/* 4815 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4818 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4830
/* 4822 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4826 */    MCD::OPC_Decode, 241, 5, 85, // Opcode: STHrr, DecodeIdx: 85
/* 4830 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4832 */    MCD::OPC_Decode, 240, 5, 86, // Opcode: STHri, DecodeIdx: 86
/* 4836 */    MCD::OPC_FilterValue, 7, 21, 0, // Skip to: 4861
/* 4840 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4843 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4855
/* 4847 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4851 */    MCD::OPC_Decode, 231, 5, 87, // Opcode: STDrr, DecodeIdx: 87
/* 4855 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4857 */    MCD::OPC_Decode, 230, 5, 88, // Opcode: STDri, DecodeIdx: 88
/* 4861 */    MCD::OPC_FilterValue, 8, 21, 0, // Skip to: 4886
/* 4865 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4868 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4880
/* 4872 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4876 */    MCD::OPC_Decode, 234, 4, 89, // Opcode: LDSWrr, DecodeIdx: 89
/* 4880 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4882 */    MCD::OPC_Decode, 233, 4, 90, // Opcode: LDSWri, DecodeIdx: 90
/* 4886 */    MCD::OPC_FilterValue, 9, 21, 0, // Skip to: 4911
/* 4890 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4893 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4905
/* 4897 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4901 */    MCD::OPC_Decode, 222, 4, 77, // Opcode: LDSBrr, DecodeIdx: 77
/* 4905 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4907 */    MCD::OPC_Decode, 221, 4, 78, // Opcode: LDSBri, DecodeIdx: 78
/* 4911 */    MCD::OPC_FilterValue, 10, 21, 0, // Skip to: 4936
/* 4915 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4918 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4930
/* 4922 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4926 */    MCD::OPC_Decode, 226, 4, 77, // Opcode: LDSHrr, DecodeIdx: 77
/* 4930 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4932 */    MCD::OPC_Decode, 225, 4, 78, // Opcode: LDSHri, DecodeIdx: 78
/* 4936 */    MCD::OPC_FilterValue, 11, 21, 0, // Skip to: 4961
/* 4940 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4943 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4955
/* 4947 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4951 */    MCD::OPC_Decode, 248, 4, 89, // Opcode: LDXrr, DecodeIdx: 89
/* 4955 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4957 */    MCD::OPC_Decode, 247, 4, 90, // Opcode: LDXri, DecodeIdx: 90
/* 4961 */    MCD::OPC_FilterValue, 13, 21, 0, // Skip to: 4986
/* 4965 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4968 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4980
/* 4972 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4976 */    MCD::OPC_Decode, 230, 4, 77, // Opcode: LDSTUBrr, DecodeIdx: 77
/* 4980 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4982 */    MCD::OPC_Decode, 229, 4, 78, // Opcode: LDSTUBri, DecodeIdx: 78
/* 4986 */    MCD::OPC_FilterValue, 14, 21, 0, // Skip to: 5011
/* 4990 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4993 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 5005
/* 4997 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5001 */    MCD::OPC_Decode, 251, 5, 91, // Opcode: STXrr, DecodeIdx: 91
/* 5005 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5007 */    MCD::OPC_Decode, 250, 5, 92, // Opcode: STXri, DecodeIdx: 92
/* 5011 */    MCD::OPC_FilterValue, 15, 21, 0, // Skip to: 5036
/* 5015 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5018 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 5030
/* 5022 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5026 */    MCD::OPC_Decode, 137, 6, 93, // Opcode: SWAPrr, DecodeIdx: 93
/* 5030 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5032 */    MCD::OPC_Decode, 136, 6, 94, // Opcode: SWAPri, DecodeIdx: 94
/* 5036 */    MCD::OPC_FilterValue, 16, 19, 0, // Skip to: 5059
/* 5040 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5043 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5051
/* 5047 */    MCD::OPC_Decode, 194, 4, 95, // Opcode: LDArr, DecodeIdx: 95
/* 5051 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5053 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5055 */    MCD::OPC_Decode, 193, 4, 78, // Opcode: LDAri, DecodeIdx: 78
/* 5059 */    MCD::OPC_FilterValue, 17, 19, 0, // Skip to: 5082
/* 5063 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5066 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5074
/* 5070 */    MCD::OPC_Decode, 236, 4, 95, // Opcode: LDUBArr, DecodeIdx: 95
/* 5074 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5076 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5078 */    MCD::OPC_Decode, 235, 4, 78, // Opcode: LDUBAri, DecodeIdx: 78
/* 5082 */    MCD::OPC_FilterValue, 18, 19, 0, // Skip to: 5105
/* 5086 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5089 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5097
/* 5093 */    MCD::OPC_Decode, 240, 4, 95, // Opcode: LDUHArr, DecodeIdx: 95
/* 5097 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5099 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5101 */    MCD::OPC_Decode, 239, 4, 78, // Opcode: LDUHAri, DecodeIdx: 78
/* 5105 */    MCD::OPC_FilterValue, 19, 19, 0, // Skip to: 5128
/* 5109 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5112 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5120
/* 5116 */    MCD::OPC_Decode, 200, 4, 96, // Opcode: LDDArr, DecodeIdx: 96
/* 5120 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5122 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5124 */    MCD::OPC_Decode, 199, 4, 84, // Opcode: LDDAri, DecodeIdx: 84
/* 5128 */    MCD::OPC_FilterValue, 20, 19, 0, // Skip to: 5151
/* 5132 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5135 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5143
/* 5139 */    MCD::OPC_Decode, 208, 5, 97, // Opcode: STArr, DecodeIdx: 97
/* 5143 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5145 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5147 */    MCD::OPC_Decode, 207, 5, 86, // Opcode: STAri, DecodeIdx: 86
/* 5151 */    MCD::OPC_FilterValue, 21, 19, 0, // Skip to: 5174
/* 5155 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5158 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5166
/* 5162 */    MCD::OPC_Decode, 211, 5, 97, // Opcode: STBArr, DecodeIdx: 97
/* 5166 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5168 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5170 */    MCD::OPC_Decode, 210, 5, 86, // Opcode: STBAri, DecodeIdx: 86
/* 5174 */    MCD::OPC_FilterValue, 22, 19, 0, // Skip to: 5197
/* 5178 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5181 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5189
/* 5185 */    MCD::OPC_Decode, 239, 5, 97, // Opcode: STHArr, DecodeIdx: 97
/* 5189 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5191 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5193 */    MCD::OPC_Decode, 238, 5, 86, // Opcode: STHAri, DecodeIdx: 86
/* 5197 */    MCD::OPC_FilterValue, 23, 19, 0, // Skip to: 5220
/* 5201 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5204 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5212
/* 5208 */    MCD::OPC_Decode, 219, 5, 98, // Opcode: STDArr, DecodeIdx: 98
/* 5212 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5214 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5216 */    MCD::OPC_Decode, 218, 5, 88, // Opcode: STDAri, DecodeIdx: 88
/* 5220 */    MCD::OPC_FilterValue, 24, 17, 0, // Skip to: 5241
/* 5224 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5227 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5235
/* 5231 */    MCD::OPC_Decode, 232, 4, 99, // Opcode: LDSWArr, DecodeIdx: 99
/* 5235 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5237 */    MCD::OPC_Decode, 231, 4, 90, // Opcode: LDSWAri, DecodeIdx: 90
/* 5241 */    MCD::OPC_FilterValue, 25, 19, 0, // Skip to: 5264
/* 5245 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5248 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5256
/* 5252 */    MCD::OPC_Decode, 220, 4, 95, // Opcode: LDSBArr, DecodeIdx: 95
/* 5256 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5258 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5260 */    MCD::OPC_Decode, 219, 4, 78, // Opcode: LDSBAri, DecodeIdx: 78
/* 5264 */    MCD::OPC_FilterValue, 26, 19, 0, // Skip to: 5287
/* 5268 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5271 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5279
/* 5275 */    MCD::OPC_Decode, 224, 4, 95, // Opcode: LDSHArr, DecodeIdx: 95
/* 5279 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5281 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5283 */    MCD::OPC_Decode, 223, 4, 78, // Opcode: LDSHAri, DecodeIdx: 78
/* 5287 */    MCD::OPC_FilterValue, 27, 17, 0, // Skip to: 5308
/* 5291 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5294 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5302
/* 5298 */    MCD::OPC_Decode, 244, 4, 99, // Opcode: LDXArr, DecodeIdx: 99
/* 5302 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5304 */    MCD::OPC_Decode, 243, 4, 90, // Opcode: LDXAri, DecodeIdx: 90
/* 5308 */    MCD::OPC_FilterValue, 29, 19, 0, // Skip to: 5331
/* 5312 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5315 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5323
/* 5319 */    MCD::OPC_Decode, 228, 4, 95, // Opcode: LDSTUBArr, DecodeIdx: 95
/* 5323 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5325 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5327 */    MCD::OPC_Decode, 227, 4, 78, // Opcode: LDSTUBAri, DecodeIdx: 78
/* 5331 */    MCD::OPC_FilterValue, 30, 17, 0, // Skip to: 5352
/* 5335 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5338 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5346
/* 5342 */    MCD::OPC_Decode, 247, 5, 100, // Opcode: STXArr, DecodeIdx: 100
/* 5346 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5348 */    MCD::OPC_Decode, 246, 5, 92, // Opcode: STXAri, DecodeIdx: 92
/* 5352 */    MCD::OPC_FilterValue, 31, 19, 0, // Skip to: 5375
/* 5356 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5359 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5367
/* 5363 */    MCD::OPC_Decode, 135, 6, 101, // Opcode: SWAPArr, DecodeIdx: 101
/* 5367 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5369 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5371 */    MCD::OPC_Decode, 134, 6, 94, // Opcode: SWAPAri, DecodeIdx: 94
/* 5375 */    MCD::OPC_FilterValue, 32, 21, 0, // Skip to: 5400
/* 5379 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5382 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 5394
/* 5386 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5390 */    MCD::OPC_Decode, 214, 4, 102, // Opcode: LDFrr, DecodeIdx: 102
/* 5394 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5396 */    MCD::OPC_Decode, 213, 4, 103, // Opcode: LDFri, DecodeIdx: 103
/* 5400 */    MCD::OPC_FilterValue, 33, 55, 0, // Skip to: 5459
/* 5404 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5407 */    MCD::OPC_FilterValue, 0, 27, 0, // Skip to: 5438
/* 5411 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 5414 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 5426
/* 5418 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5422 */    MCD::OPC_Decode, 212, 4, 79, // Opcode: LDFSRrr, DecodeIdx: 79
/* 5426 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5428 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5430 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5434 */    MCD::OPC_Decode, 246, 4, 79, // Opcode: LDXFSRrr, DecodeIdx: 79
/* 5438 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5440 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 5443 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5451
/* 5447 */    MCD::OPC_Decode, 211, 4, 80, // Opcode: LDFSRri, DecodeIdx: 80
/* 5451 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5453 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5455 */    MCD::OPC_Decode, 245, 4, 80, // Opcode: LDXFSRri, DecodeIdx: 80
/* 5459 */    MCD::OPC_FilterValue, 35, 21, 0, // Skip to: 5484
/* 5463 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5466 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 5478
/* 5470 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5474 */    MCD::OPC_Decode, 206, 4, 104, // Opcode: LDDFrr, DecodeIdx: 104
/* 5478 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5480 */    MCD::OPC_Decode, 205, 4, 105, // Opcode: LDDFri, DecodeIdx: 105
/* 5484 */    MCD::OPC_FilterValue, 36, 21, 0, // Skip to: 5509
/* 5488 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5491 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 5503
/* 5495 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5499 */    MCD::OPC_Decode, 237, 5, 106, // Opcode: STFrr, DecodeIdx: 106
/* 5503 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5505 */    MCD::OPC_Decode, 236, 5, 107, // Opcode: STFri, DecodeIdx: 107
/* 5509 */    MCD::OPC_FilterValue, 37, 55, 0, // Skip to: 5568
/* 5513 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5516 */    MCD::OPC_FilterValue, 0, 27, 0, // Skip to: 5547
/* 5520 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 5523 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 5535
/* 5527 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5531 */    MCD::OPC_Decode, 235, 5, 79, // Opcode: STFSRrr, DecodeIdx: 79
/* 5535 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5537 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5539 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5543 */    MCD::OPC_Decode, 249, 5, 79, // Opcode: STXFSRrr, DecodeIdx: 79
/* 5547 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5549 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 5552 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5560
/* 5556 */    MCD::OPC_Decode, 234, 5, 80, // Opcode: STFSRri, DecodeIdx: 80
/* 5560 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5562 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5564 */    MCD::OPC_Decode, 248, 5, 80, // Opcode: STXFSRri, DecodeIdx: 80
/* 5568 */    MCD::OPC_FilterValue, 38, 29, 0, // Skip to: 5601
/* 5572 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5575 */    MCD::OPC_FilterValue, 0, 12, 0, // Skip to: 5591
/* 5579 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 5583 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5587 */    MCD::OPC_Decode, 227, 5, 79, // Opcode: STDFQrr, DecodeIdx: 79
/* 5591 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5593 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 5597 */    MCD::OPC_Decode, 226, 5, 80, // Opcode: STDFQri, DecodeIdx: 80
/* 5601 */    MCD::OPC_FilterValue, 39, 21, 0, // Skip to: 5626
/* 5605 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5608 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 5620
/* 5612 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5616 */    MCD::OPC_Decode, 229, 5, 108, // Opcode: STDFrr, DecodeIdx: 108
/* 5620 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5622 */    MCD::OPC_Decode, 228, 5, 109, // Opcode: STDFri, DecodeIdx: 109
/* 5626 */    MCD::OPC_FilterValue, 45, 25, 0, // Skip to: 5655
/* 5630 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5633 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5647
/* 5637 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5639 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5643 */    MCD::OPC_Decode, 159, 5, 110, // Opcode: PREFETCHr, DecodeIdx: 110
/* 5647 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5649 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5651 */    MCD::OPC_Decode, 158, 5, 111, // Opcode: PREFETCHi, DecodeIdx: 111
/* 5655 */    MCD::OPC_FilterValue, 49, 29, 0, // Skip to: 5688
/* 5659 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5662 */    MCD::OPC_FilterValue, 0, 12, 0, // Skip to: 5678
/* 5666 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 5670 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5674 */    MCD::OPC_Decode, 196, 4, 79, // Opcode: LDCSRrr, DecodeIdx: 79
/* 5678 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5680 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 5684 */    MCD::OPC_Decode, 195, 4, 80, // Opcode: LDCSRri, DecodeIdx: 80
/* 5688 */    MCD::OPC_FilterValue, 53, 29, 0, // Skip to: 5721
/* 5692 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5695 */    MCD::OPC_FilterValue, 0, 12, 0, // Skip to: 5711
/* 5699 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 5703 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5707 */    MCD::OPC_Decode, 215, 5, 79, // Opcode: STCSRrr, DecodeIdx: 79
/* 5711 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5713 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 5717 */    MCD::OPC_Decode, 214, 5, 80, // Opcode: STCSRri, DecodeIdx: 80
/* 5721 */    MCD::OPC_FilterValue, 54, 29, 0, // Skip to: 5754
/* 5725 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5728 */    MCD::OPC_FilterValue, 0, 12, 0, // Skip to: 5744
/* 5732 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 5736 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5740 */    MCD::OPC_Decode, 221, 5, 79, // Opcode: STDCQrr, DecodeIdx: 79
/* 5744 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5746 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 5750 */    MCD::OPC_Decode, 220, 5, 80, // Opcode: STDCQri, DecodeIdx: 80
/* 5754 */    MCD::OPC_FilterValue, 60, 25, 0, // Skip to: 5783
/* 5758 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5761 */    MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 5771
/* 5765 */    MCD::OPC_CheckPredicateOrFail, 8, 
/* 5767 */    MCD::OPC_Decode, 254, 2, 112, // Opcode: CASArr, DecodeIdx: 112
/* 5771 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5773 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5775 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5779 */    MCD::OPC_Decode, 253, 2, 113, // Opcode: CASAri, DecodeIdx: 113
/* 5783 */    MCD::OPC_FilterValue, 61, 21, 0, // Skip to: 5808
/* 5787 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5790 */    MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 5800
/* 5794 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5796 */    MCD::OPC_Decode, 157, 5, 114, // Opcode: PREFETCHAr, DecodeIdx: 114
/* 5800 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5802 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5804 */    MCD::OPC_Decode, 156, 5, 111, // Opcode: PREFETCHAi, DecodeIdx: 111
/* 5808 */    MCD::OPC_FilterValueOrFail, 62, 
/* 5810 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5813 */    MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 5823
/* 5817 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5819 */    MCD::OPC_Decode, 128, 3, 115, // Opcode: CASXArr, DecodeIdx: 115
/* 5823 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5825 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5827 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5831 */    MCD::OPC_Decode, 255, 2, 116, // Opcode: CASXAri, DecodeIdx: 116
/* 5835 */    MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableSparcV832[] = {
/* 0 */       MCD::OPC_ExtractField, 19, 6,  // Inst{24-19} ...
/* 3 */       MCD::OPC_FilterValue, 48, 29, 0, // Skip to: 36
/* 7 */       MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 10 */      MCD::OPC_FilterValue, 0, 12, 0, // Skip to: 26
/* 14 */      MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 18 */      MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 22 */      MCD::OPC_Decode, 198, 4, 117, // Opcode: LDCrr, DecodeIdx: 117
/* 26 */      MCD::OPC_FilterValueOrFail, 1, 
/* 28 */      MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 32 */      MCD::OPC_Decode, 197, 4, 118, // Opcode: LDCri, DecodeIdx: 118
/* 36 */      MCD::OPC_FilterValue, 51, 29, 0, // Skip to: 69
/* 40 */      MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 43 */      MCD::OPC_FilterValue, 0, 12, 0, // Skip to: 59
/* 47 */      MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 51 */      MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 55 */      MCD::OPC_Decode, 202, 4, 119, // Opcode: LDDCrr, DecodeIdx: 119
/* 59 */      MCD::OPC_FilterValueOrFail, 1, 
/* 61 */      MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 65 */      MCD::OPC_Decode, 201, 4, 120, // Opcode: LDDCri, DecodeIdx: 120
/* 69 */      MCD::OPC_FilterValue, 52, 29, 0, // Skip to: 102
/* 73 */      MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 76 */      MCD::OPC_FilterValue, 0, 12, 0, // Skip to: 92
/* 80 */      MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 84 */      MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 88 */      MCD::OPC_Decode, 217, 5, 121, // Opcode: STCrr, DecodeIdx: 121
/* 92 */      MCD::OPC_FilterValueOrFail, 1, 
/* 94 */      MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 98 */      MCD::OPC_Decode, 216, 5, 122, // Opcode: STCri, DecodeIdx: 122
/* 102 */     MCD::OPC_FilterValue, 55, 29, 0, // Skip to: 135
/* 106 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 109 */     MCD::OPC_FilterValue, 0, 12, 0, // Skip to: 125
/* 113 */     MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 117 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 121 */     MCD::OPC_Decode, 223, 5, 123, // Opcode: STDCrr, DecodeIdx: 123
/* 125 */     MCD::OPC_FilterValueOrFail, 1, 
/* 127 */     MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 131 */     MCD::OPC_Decode, 222, 5, 124, // Opcode: STDCri, DecodeIdx: 124
/* 135 */     MCD::OPC_FilterValueOrFail, 58, 
/* 137 */     MCD::OPC_ExtractField, 8, 6,  // Inst{13-8} ...
/* 140 */     MCD::OPC_FilterValue, 0, 12, 0, // Skip to: 156
/* 144 */     MCD::OPC_CheckFieldOrFail, 29, 3, 4, 
/* 148 */     MCD::OPC_CheckFieldOrFail, 5, 3, 0, 
/* 152 */     MCD::OPC_Decode, 154, 6, 81, // Opcode: TRAPrr, DecodeIdx: 81
/* 156 */     MCD::OPC_FilterValueOrFail, 32, 
/* 158 */     MCD::OPC_CheckFieldOrFail, 29, 3, 4, 
/* 162 */     MCD::OPC_Decode, 153, 6, 82, // Opcode: TRAPri, DecodeIdx: 82
/* 166 */     MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableSparcV932[] = {
/* 0 */       MCD::OPC_ExtractField, 19, 6,  // Inst{24-19} ...
/* 3 */       MCD::OPC_FilterValue, 34, 33, 0, // Skip to: 40
/* 7 */       MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 10 */      MCD::OPC_FilterValue, 0, 14, 0, // Skip to: 28
/* 14 */      MCD::OPC_CheckPredicateOrFail, 0, 
/* 16 */      MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 20 */      MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 24 */      MCD::OPC_Decode, 218, 4, 125, // Opcode: LDQFrr, DecodeIdx: 125
/* 28 */      MCD::OPC_FilterValueOrFail, 1, 
/* 30 */      MCD::OPC_CheckPredicateOrFail, 0, 
/* 32 */      MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 36 */      MCD::OPC_Decode, 217, 4, 126, // Opcode: LDQFri, DecodeIdx: 126
/* 40 */      MCD::OPC_FilterValue, 38, 34, 0, // Skip to: 78
/* 44 */      MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 47 */      MCD::OPC_FilterValue, 0, 14, 0, // Skip to: 65
/* 51 */      MCD::OPC_CheckPredicateOrFail, 0, 
/* 53 */      MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 57 */      MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 61 */      MCD::OPC_Decode, 245, 5, 127, // Opcode: STQFrr, DecodeIdx: 127
/* 65 */      MCD::OPC_FilterValueOrFail, 1, 
/* 67 */      MCD::OPC_CheckPredicateOrFail, 0, 
/* 69 */      MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 73 */      MCD::OPC_Decode, 244, 5, 128, 1, // Opcode: STQFri, DecodeIdx: 128
/* 78 */      MCD::OPC_FilterValue, 48, 30, 0, // Skip to: 112
/* 82 */      MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 85 */      MCD::OPC_FilterValue, 0, 11, 0, // Skip to: 100
/* 89 */      MCD::OPC_CheckPredicateOrFail, 0, 
/* 91 */      MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 95 */      MCD::OPC_Decode, 210, 4, 129, 1, // Opcode: LDFArr, DecodeIdx: 129
/* 100 */     MCD::OPC_FilterValueOrFail, 1, 
/* 102 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 104 */     MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 108 */     MCD::OPC_Decode, 209, 4, 103, // Opcode: LDFAri, DecodeIdx: 103
/* 112 */     MCD::OPC_FilterValue, 50, 30, 0, // Skip to: 146
/* 116 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 119 */     MCD::OPC_FilterValue, 0, 11, 0, // Skip to: 134
/* 123 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 125 */     MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 129 */     MCD::OPC_Decode, 216, 4, 130, 1, // Opcode: LDQFArr, DecodeIdx: 130
/* 134 */     MCD::OPC_FilterValueOrFail, 1, 
/* 136 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 138 */     MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 142 */     MCD::OPC_Decode, 215, 4, 126, // Opcode: LDQFAri, DecodeIdx: 126
/* 146 */     MCD::OPC_FilterValue, 51, 30, 0, // Skip to: 180
/* 150 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 153 */     MCD::OPC_FilterValue, 0, 11, 0, // Skip to: 168
/* 157 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 159 */     MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 163 */     MCD::OPC_Decode, 204, 4, 131, 1, // Opcode: LDDFArr, DecodeIdx: 131
/* 168 */     MCD::OPC_FilterValueOrFail, 1, 
/* 170 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 172 */     MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 176 */     MCD::OPC_Decode, 203, 4, 105, // Opcode: LDDFAri, DecodeIdx: 105
/* 180 */     MCD::OPC_FilterValue, 52, 30, 0, // Skip to: 214
/* 184 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 187 */     MCD::OPC_FilterValue, 0, 11, 0, // Skip to: 202
/* 191 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 193 */     MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 197 */     MCD::OPC_Decode, 233, 5, 132, 1, // Opcode: STFArr, DecodeIdx: 132
/* 202 */     MCD::OPC_FilterValueOrFail, 1, 
/* 204 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 206 */     MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 210 */     MCD::OPC_Decode, 232, 5, 107, // Opcode: STFAri, DecodeIdx: 107
/* 214 */     MCD::OPC_FilterValue, 54, 31, 0, // Skip to: 249
/* 218 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 221 */     MCD::OPC_FilterValue, 0, 11, 0, // Skip to: 236
/* 225 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 227 */     MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 231 */     MCD::OPC_Decode, 243, 5, 133, 1, // Opcode: STQFArr, DecodeIdx: 133
/* 236 */     MCD::OPC_FilterValueOrFail, 1, 
/* 238 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 240 */     MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 244 */     MCD::OPC_Decode, 242, 5, 128, 1, // Opcode: STQFAri, DecodeIdx: 128
/* 249 */     MCD::OPC_FilterValue, 55, 30, 0, // Skip to: 283
/* 253 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 256 */     MCD::OPC_FilterValue, 0, 11, 0, // Skip to: 271
/* 260 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 262 */     MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 266 */     MCD::OPC_Decode, 225, 5, 134, 1, // Opcode: STDFArr, DecodeIdx: 134
/* 271 */     MCD::OPC_FilterValueOrFail, 1, 
/* 273 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 275 */     MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 279 */     MCD::OPC_Decode, 224, 5, 109, // Opcode: STDFAri, DecodeIdx: 109
/* 283 */     MCD::OPC_FilterValueOrFail, 58, 
/* 285 */     MCD::OPC_ExtractField, 8, 6,  // Inst{13-8} ...
/* 288 */     MCD::OPC_FilterValue, 0, 14, 0, // Skip to: 306
/* 292 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 294 */     MCD::OPC_CheckFieldOrFail, 29, 3, 4, 
/* 298 */     MCD::OPC_CheckFieldOrFail, 5, 3, 0, 
/* 302 */     MCD::OPC_Decode, 148, 6, 81, // Opcode: TICCrr, DecodeIdx: 81
/* 306 */     MCD::OPC_FilterValueOrFail, 32, 
/* 308 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 310 */     MCD::OPC_CheckFieldOrFail, 29, 3, 4, 
/* 314 */     MCD::OPC_Decode, 147, 6, 82, // Opcode: TICCri, DecodeIdx: 82
/* 318 */     MCD::OPC_Fail,
  0
};

static bool checkDecoderPredicate(unsigned Idx, const FeatureBitset &Bits) {
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    return (Bits[Sparc::FeatureV9]);
  case 1:
    return (Bits[Sparc::FeatureOSA2011]);
  case 2:
    return (Bits[Sparc::FeaturePWRPSR]);
  case 3:
    return (Bits[Sparc::FeatureUA2005]);
  case 4:
    return (Bits[Sparc::FeatureVIS3]);
  case 5:
    return (Bits[Sparc::FeatureVIS]);
  case 6:
    return (Bits[Sparc::FeatureVIS2]);
  case 7:
    return (Bits[Sparc::FeatureUA2007]);
  case 8:
    return (Bits[Sparc::LeonCASA] || Bits[Sparc::FeatureV9]);
  }
}

template <typename InsnType>
static DecodeStatus decodeToMCInst(DecodeStatus S, unsigned Idx, InsnType insn, MCInst &MI,
                                   uint64_t Address, const MCDisassembler *Decoder, bool &DecodeComplete) {
  DecodeComplete = true;
  using TmpType = std::conditional_t<std::is_integral<InsnType>::value, InsnType, uint64_t>;
  TmpType tmp;
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    tmp = fieldFromInstruction(insn, 0, 22);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 1:
    tmp = fieldFromInstruction(insn, 0, 19);
    if (!Check(S, DecodeDisp<19>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 2:
    tmp = fieldFromInstruction(insn, 0, 22);
    if (!Check(S, DecodeDisp<22>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 3:
    tmp = fieldFromInstruction(insn, 0, 22);
    if (!Check(S, DecodeDisp<22>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 4:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 14), 0, 14);
    insertBits(tmp, fieldFromInstruction(insn, 20, 2), 14, 2);
    if (!Check(S, DecodeDisp<16>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 5:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 5, 8), 0, 8);
    insertBits(tmp, fieldFromInstruction(insn, 19, 2), 8, 2);
    if (!Check(S, DecodeDisp<10>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 25, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 29, 1), 3, 1);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 6:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 5, 8), 0, 8);
    insertBits(tmp, fieldFromInstruction(insn, 19, 2), 8, 2);
    if (!Check(S, DecodeDisp<10>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 25, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 29, 1), 3, 1);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeSIMM5(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 7:
    return S;
  case 8:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 22);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 9:
    tmp = fieldFromInstruction(insn, 0, 19);
    if (!Check(S, DecodeDisp<19>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 20, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 10:
    tmp = fieldFromInstruction(insn, 0, 30);
    if (!Check(S, DecodeCall(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 11:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 12:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 13:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 14:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 15:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 16:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 17:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 18:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeASRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 19:
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 20:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 21:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 22:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 23:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 24:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 11);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 25:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 11);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 26:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 27:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 28:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 10);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 29:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeASRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 30:
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 31:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeASRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 32:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 33:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 34:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodePRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 35:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodePRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 36:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 37:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 38:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 39:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 40:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 41:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 42:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 43:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 44:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 45:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 46:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 47:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 48:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 49:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 50:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 51:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 52:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 53:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 54:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 55:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 56:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 57:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 58:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 59:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 60:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 61:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 62:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 63:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 64:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 65:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 66:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 67:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 68:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 69:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 70:
    tmp = fieldFromInstruction(insn, 0, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 71:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 72:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 73:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 74:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 75:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 76:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 77:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 78:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 79:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 80:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 81:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 82:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 83:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 84:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 85:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 86:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 87:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 88:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 89:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 90:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 91:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 92:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 93:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 94:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 95:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 96:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 97:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 98:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 99:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 100:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 101:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 102:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 103:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 104:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 105:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 106:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 107:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 108:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 109:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 110:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 111:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 112:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 113:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 114:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 115:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 116:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 117:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 118:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 119:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 120:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 121:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 122:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 123:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 124:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 125:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 126:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 127:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 128:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 129:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 130:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 131:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 132:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 133:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 134:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  }
}

static unsigned decodeNumToSkip(const uint8_t *&Ptr) {
  unsigned NumToSkip = *Ptr++;
  NumToSkip |= (*Ptr++) << 8;
  return NumToSkip;
}

template <typename InsnType>
static DecodeStatus decodeInstruction(const uint8_t DecodeTable[], MCInst &MI,
                                      InsnType insn, uint64_t Address,
                                      const MCDisassembler *DisAsm,
                                      const MCSubtargetInfo &STI) {
  const FeatureBitset &Bits = STI.getFeatureBits();

  const uint8_t *Ptr = DecodeTable;
  uint64_t CurFieldValue = 0;
  DecodeStatus S = MCDisassembler::Success;
  while (true) {
    ptrdiff_t Loc = Ptr - DecodeTable;
    const uint8_t DecoderOp = *Ptr++;
    switch (DecoderOp) {
    default:
      errs() << Loc << ": Unexpected decode table opcode: "
             << (int)DecoderOp << '\n';
      return MCDisassembler::Fail;
    case MCD::OPC_ExtractField: {
      // Decode the start value.
      unsigned Start = decodeULEB128AndIncUnsafe(Ptr);
      unsigned Len = *Ptr++;
      CurFieldValue = fieldFromInstruction(insn, Start, Len);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_ExtractField(" << Start << ", "
                   << Len << "): " << CurFieldValue << "\n");
      break;
    }
    case MCD::OPC_FilterValue:
    case MCD::OPC_FilterValueOrFail: {
      bool IsFail = DecoderOp == MCD::OPC_FilterValueOrFail;
      // Decode the field value.
      uint64_t Val = decodeULEB128AndIncUnsafe(Ptr);
      bool Failed = Val != CurFieldValue;
      unsigned NumToSkip = IsFail ? 0 : decodeNumToSkip(Ptr);

      // Note: Print NumToSkip even for OPC_FilterValueOrFail to simplify debug
      // prints.
      LLVM_DEBUG({
        StringRef OpName = IsFail ? "OPC_FilterValueOrFail" : "OPC_FilterValue";
        dbgs() << Loc << ": " << OpName << '(' << Val << ", " << NumToSkip
                << ") " << (Failed ? "FAIL:" : "PASS:")
                << " continuing at " << (Ptr - DecodeTable) << '\n';
      });

      // Perform the filter operation.
      if (Failed) {
        if (IsFail)
          return MCDisassembler::Fail;
        Ptr += NumToSkip;
      }
      break;
    }
    case MCD::OPC_CheckField:
    case MCD::OPC_CheckFieldOrFail: {
      bool IsFail = DecoderOp == MCD::OPC_CheckFieldOrFail;
      // Decode the start value.
      unsigned Start = decodeULEB128AndIncUnsafe(Ptr);
      unsigned Len = *Ptr;
      uint64_t FieldValue = fieldFromInstruction(insn, Start, Len);
      // Decode the field value.
      unsigned PtrLen = 0;
      uint64_t ExpectedValue = decodeULEB128(++Ptr, &PtrLen);
      Ptr += PtrLen;
      bool Failed = ExpectedValue != FieldValue;
      unsigned NumToSkip = IsFail ? 0 : decodeNumToSkip(Ptr);

      LLVM_DEBUG({
        StringRef OpName = IsFail ? "OPC_CheckFieldOrFail" : "OPC_CheckField";
        dbgs() << Loc << ": " << OpName << '(' << Start << ", " << Len << ", "
                << ExpectedValue << ", " << NumToSkip << "): FieldValue = "
                << FieldValue << ", ExpectedValue = " << ExpectedValue << ": "
                << (Failed ? "FAIL\n" : "PASS\n");
      });

      // If the actual and expected values don't match, skip or fail.
      if (Failed) {
        if (IsFail)
          return MCDisassembler::Fail;
        Ptr += NumToSkip;
      }
      break;
    }
    case MCD::OPC_CheckPredicate:
    case MCD::OPC_CheckPredicateOrFail: {
      bool IsFail = DecoderOp == MCD::OPC_CheckPredicateOrFail;
      // Decode the Predicate Index value.
      unsigned PIdx = decodeULEB128AndIncUnsafe(Ptr);
      unsigned NumToSkip = IsFail ? 0 : decodeNumToSkip(Ptr);
      // Check the predicate.
      bool Failed = !checkDecoderPredicate(PIdx, Bits);

      LLVM_DEBUG({
        StringRef OpName = IsFail ? "OPC_CheckPredicateOrFail" : "OPC_CheckPredicate";
        dbgs() << Loc << ": " << OpName << '(' << PIdx << ", " << NumToSkip
               << "): " << (Failed ? "FAIL\n" : "PASS\n");
      });

      if (Failed) {
        if (IsFail)
          return MCDisassembler::Fail;
        Ptr += NumToSkip;
      }
      break;
    }
    case MCD::OPC_Decode: {
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128AndIncUnsafe(Ptr);
      unsigned DecodeIdx = decodeULEB128AndIncUnsafe(Ptr);

      MI.clear();
      MI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, MI, Address, DisAsm, DecodeComplete);
      assert(DecodeComplete);

      LLVM_DEBUG(dbgs() << Loc << ": OPC_Decode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": "
                   << (S != MCDisassembler::Fail ? "PASS\n" : "FAIL\n"));
      return S;
    }
    case MCD::OPC_TryDecode:
    case MCD::OPC_TryDecodeOrFail: {
      bool IsFail = DecoderOp == MCD::OPC_TryDecodeOrFail;
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128AndIncUnsafe(Ptr);
      unsigned DecodeIdx = decodeULEB128AndIncUnsafe(Ptr);
      unsigned NumToSkip = IsFail ? 0 : decodeNumToSkip(Ptr);

      // Perform the decode operation.
      MCInst TmpMI;
      TmpMI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, TmpMI, Address, DisAsm, DecodeComplete);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_TryDecode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": ");

      if (DecodeComplete) {
        // Decoding complete.
        LLVM_DEBUG(dbgs() << (S != MCDisassembler::Fail ? "PASS\n" : "FAIL\n"));
        MI = TmpMI;
        return S;
      }
      assert(S == MCDisassembler::Fail);
      if (IsFail) {
        LLVM_DEBUG(dbgs() << "FAIL: returning FAIL\n");
        return MCDisassembler::Fail;
      }
      // If the decoding was incomplete, skip.
      Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << "FAIL: continuing at " << (Ptr - DecodeTable) << "\n");
      // Reset decode status. This also drops a SoftFail status that could be
      // set before the decode attempt.
      S = MCDisassembler::Success;
      break;
    }
    case MCD::OPC_SoftFail: {
      // Decode the mask values.
      uint64_t PositiveMask = decodeULEB128AndIncUnsafe(Ptr);
      uint64_t NegativeMask = decodeULEB128AndIncUnsafe(Ptr);
      bool Failed = (insn & PositiveMask) != 0 || (~insn & NegativeMask) != 0;
      if (Failed)
        S = MCDisassembler::SoftFail;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_SoftFail: " << (Failed ? "FAIL\n" : "PASS\n"));
      break;
    }
    case MCD::OPC_Fail: {
      LLVM_DEBUG(dbgs() << Loc << ": OPC_Fail\n");
      return MCDisassembler::Fail;
    }
    }
  }
  llvm_unreachable("bogosity detected in disassembler state machine!");
}


} // namespace
